
Vue.component('common-header', {
    template: '<div class="pageTitle" :style="{height:immersive ? \'0px\' : \'64px\'}">'+
        '<cite :style="getStyle">'+
            '<a v-if="!noback" class="pageTitle_toback" @click="toBack"><i class="iconfont icon-fanhui"></i></a>'+
            '<h2 v-text="title"></h2>'+
            '<slot></slot>'+
        '</cite>'+
    '</div>',
    data:function() {
        return {
            
        }
    },
    props:{
        title:'', //标题
        rightIcon:'',//右侧icon
        immersive:{ //菜单是否沉浸式 true: 不占据高度 
            type:Boolean,
            default:()=>false
        },
        noback:{  //是否带上返回按钮，默认是可以返回
            type:Boolean,
            default:()=>false
        },
    },
    computed:{
        getStyle(){
            return {backgroundColor:this.immersive ? 'transparent' : '#fff',boxShadow:this.immersive ? 'none' : '0 0 5px rgba(0,0,0,0.1)'}
        }
    },
    created: function() {

    },
    methods: {
        toBack(){
            this.$toBack();
            this.$emit('toBack');//监听返回
        }
        
    },
    
});
