
Vue.directive('DragBtn', {
    update: function (el, value, vNode) {
        var defaultR = 20;  // 自动贴边右边距
        var defaultB = 20; // 自动贴边底边距 这个暂时没做判断，没有支持
        var disX = 0;
        var disY = 0;
        var elW = 0;
        var elH = 0;
        var winW = document.documentElement.clientWidth;
        var winH = document.documentElement.clientHeight;

        if(value && value.value){
            var {right,bottom} = value.value;
            parseInt(right) && (defaultR = right)
            parseInt(bottom) && (defaultB = bottom)
        }

        el.ontouchstart = function (e) {
            el.classList.remove('animate');

            var touch = e.touches[0];
            disX = touch.clientX - el.offsetLeft;
            disY = touch.clientY - el.offsetTop;

            elW = el.offsetWidth;
            elH = el.offsetHeight;
        }
        el.ontouchmove = function (e) {
            //通过事件委托，计算移动的距离
            var touch = e.touches[0]
            var l = touch.clientX - disX;
            var t = touch.clientY - disY;

            if(l <= 0){
                l = 0;
            }else if(l >= (winW - elW) ){
                l = winW - elW;
            }

            if(t <= 0){
                t = 0;
            }else if(t >= (winH - elH)){
                t = winH - elH;
            }

            //移动当前元素
            el.style.left = l + "px";
            el.style.top = t + "px";

            el.ontouchend = function (e) {
                var lDistance = winW/2 - el.offsetWidth/2;
                var l = defaultR; // 默认边距

                el.classList.add('animate');
                // 判断自动贴左，或者贴右
                if(el.offsetLeft < lDistance){ // 靠左边
                    el.style.left = l + "px";
                }else{ // 靠右
                    l = winW - defaultR - el.offsetWidth;
                    el.style.left = l + "px";
                }

                document.ontouchmove = null;
                document.ontouchend = null;
            }

            return false
        }
    }
});

