Vue.component('main-collect', {
	template: 
	'<div class="main_collect" >'+
		'<div class="title"><cite><h2>图片收藏</h2><span class="title_button" v-show="login" style="display: none;" @click="selectable = !selectable" v-text="selectable ? \'取消\' : \'管理\'"></span></cite></div>'+
		'<div class="main_collect_login" v-show="!login" style="display: none;">'+
			'<p>'+
				'<i class="iconfont icon-ku"></i>'+
				'<strong>您还未登录</strong>'+
				'<span>(请先登录再查看您收藏的图片)</span>'+
				'<a @click="$toLink(\'index_login.html\')">点我登录</a>'+
			'</p>'+
		'</div>'+
		'<div class="collect_warp">'+
			'<div class="collect_sidebar">'+
				'<ul>'+
					'<li v-for="(item,index) in folder.list" :key="index" :class="{active:activeSideIndex == index}" @click="folderClick(item)"><span v-text="item.name"></span></li>'+
					'<li class="collect_sidebar_add" v-show="folder.list.length > 0" @click="folderOpen()"><i class="iconfont icon-gengduo"></i></li>'+
				'</ul>'+
			'</div>'+
			'<div class="collect_list" ref="outer" v-loading="loading">'+
				'<vue-scroller ref="scroller" v-if="login && cache.pages.length>0"'+
					':items="cache.pages" '+
					':infinite="true" '+
					':pulldown="true" '+
					':column="2" '+
					':margin="10" '+
					':spacing="10" '+
					'@onloadmore="pagesUpdata(false)" '+
					'@onpullrefresh="pagesUpdata(true)"'+
				'>'+
					'<template slot="content" slot-scope="props">' +
						'<div class="main_collect_gallery" :class="{selected:selectable && props.item.selected,disabled:selectable && props.item.disabled}" @click="selectItem(props.item)">' +
							'<figure :style="{paddingBottom: props.item.paddingBottom}">' +
								'<img :src="$cache(props.item.smallUrl)" >' +
								'<i v-if="props.item.type == \'video\'" class="iconfont icon-play"></i>'+
							'</figure>' +
							'<h3 v-text="props.item.name"></h3>' +
							'<p v-text="$dateFormat(props.item.collectedAt)"></p>' +
							'<h6 v-show="selectable"><i v-text="props.item.selectindex"></i></h6>' +
						'</div>' +
					'</template>' +
				'</vue-scroller>'+
				'<div class="scroller-nodata" v-show="login && !loading && (!cache.pages || cache.pages.length == 0)" >'+
					'<p>'+
						'<i class="iconfont icon-wushuju"></i>'+
						'<strong>暂无收藏</strong>'+
						'<span>(在分类图库中开始收藏吧)</span>'+
					'</p>'+
				'</div>'+
			'</div>'+

			'<div class="main_collect_folder" v-show="folder.show" style="display:none">'+
				'<div class="main_collect_folder_mask"></div>'+
				'<cite>'+
					'<h6 @click="folder.show = false"><i class="iconfont icon-guanbi"></i></h6>'+
					'<h3 v-if="folder.isselect">移动到收藏夹</h3>'+
					'<h3 v-else>收藏夹管理</h3>'+
					'<ul>'+
						'<li v-for="(item,index) in folder.cache" :key="index" >'+
							'<small @click="folder.selected = item" v-if="folder.isselect" v-text="item.name" :class="{selected:folder.selected == item}"></small>'+
							'<label v-else><input :disabled="folder.isselect" v-model="item.name" placeholder="请输入收藏夹名称" /></label>'+
							'<i @click="folderUpdate(item,\'toup\')" v-show="!folder.isselect" class="iconfont icon-shangyi"></i>'+
							'<i @click="folderUpdate(item,\'down\')" v-show="!folder.isselect" class="iconfont icon-xiayi"></i>'+
							'<i @click="folderUpdate(item,\'remove\')" v-show="!folder.isselect" class="iconfont icon-shanchu"></i>'+
						'</li>'+
						'<li v-if="!folder.isselect" class="main_collect_folder_add" @click="folderUpdate(null,\'insert\')" ><i></i>创建收藏夹</li>'+
					'</ul>'+
					'<h5><span @click="folderConfirm()">确定</span><span @click="folder.show = false">取消</span></h5>'+
				'</cite>'+
			'</div>'+
			'<div class="main_collect_select" v-show="selectable" style="display: none;">'+
				'<span @click="selectAll()" :class="{active:selectall}"><i class="iconfont icon-checkboxselect"></i><em></em></span>'+
				'<strong>已经选中{{selected.length}}张图片</strong>'+
				'<a @click="folderOpen(true)"><em>移动</em></a>'+
				'<a @click="cancelCollect()"><i class="iconfont icon-quxiaoshoucang"></i><em>取消收藏</em></a>'+
			'</div>'+
		'</div>'+
	'</div>',
	props: {
		selectable: { type: Boolean, default: false },
		selected: { type: Array, default: [] },
		disabled: { type: Array, default: [] },
		forbiden: { type: String,default: ''},
	},
	data: function() {
		return {
			loading: true,
			nomore: false,
			selectall: false,
			cache: { form: { folderId: 0, currentPage: 0, showCount: 20 }, pages: [] },
			activeSideIndex: 0,
			folder: {
				show: false,
				loading:false,
				isselect:false,
				selected:null,
				form: { currentPage: 1, showCount: 999 }, //文件夹一页拿完
				list: [],
				cache:[], // 缓存
			},
		}
	},
	computed:{
		
	},
	methods: {

		// 获取文件夹列表
		getFolderList: function(callback) {
			var that = this;

			// that.loading = true;
			this.$ajax('collect_folder', that.folder.form, function(res) {
				// that.loading = false;
				if (res.code == 200) {
					that.folder.list = res.data.records || [];
					that.pagesUpdata(true);
					callback && callback()
				} else {
					that.loading = false;
					that.$toast(res.message || '获取收藏夹失败');
				}
			});
		},

		// 点击收藏夹
		folderClick: function(item) {
			var index = this.folder.list.indexOf(item);
			if (this.activeSideIndex == index) {
				// 同一个，什么也不要做
			} else {
				this.activeSideIndex = index;
				this.pagesUpdata(true);
			}
		},

		// 打开对话框
		folderOpen:function(isselect){

			if(isselect && this.selected.length == 0){
				this.$toast('请先选择图片'); 
				return; 
			}
			var list = JSON.parse(JSON.stringify(this.folder.list));

			// 把默认文件夹去掉
			list = list.filter(function(item){return item.id});

			this.folder.isselect = isselect;
			this.folder.cache = list;
			this.folder.loading = false;
			this.folder.selected = null;
			this.folder.show = true;
		},

		// 更新收藏夹
		folderUpdate:function(item,type){ 
			var index = this.folder.cache.indexOf(item);

			if(type == 'insert'){

				var count = this.folder.cache.length + 1;
				this.folder.cache.push({
					id:-1,
					name:'收藏夹'+ count,
				});

				this.$nextTick(function(){
					var input = document.querySelectorAll('.main_collect_folder input');
					var last = input ? input[input.length - 1] : null;
					last && this.$setKeyboard({target:last})
				})

			}else if(type == 'remove'){

				if(item.id == 0){
					this.$toast('默认收藏夹不能删除');
				}else{
					this.folder.cache.splice(index,1);	
				}
				
			}else if(type == 'toup'){
				this.folder.cache.splice(index,1);
				this.folder.cache.splice(Math.max(0,index-1),0,item);
			}else if(type == 'down'){
				this.folder.cache.splice(index,1);
				this.folder.cache.splice(Math.min(this.folder.cache.length,index+1),0,item);
			}
		},
	
		
		// 确认修改
		folderConfirm:function(){

			var that = this;
			if(this.folder.isselect){
				// 移动图片到收藏夹
				if(this.folder.selected){
					var request = {
						folderId: this.folder.selected.id,
						ids: this.selected.map(function(i) { return i.id }).join(',')
					};
					this.loading = true;
					this.$ajax('collect_moveToFolder', request, function(res) {
						var json = res || {};
						that.loading = false;
						that.folder.show = false;
						
						if (json.code == 200) {
							that.selected.length = 0;
							that.selectFilter();
							that.pagesUpdata(true);
							that.$toast('移动成功');
						} else {
							that.$toast(json.message || '移动失败');
						}
					});

				}else{
					that.$toast('请选中要移入的收藏夹');
				}
			}else{
				// 增删编查
				// 原来的内容
				var folderObj = {};
				// 变更的内容
				var request = [];
				// 当前选中的
				var current = this.folder.list[this.activeSideIndex] || this.folder.list[0] || {};

				// 把原来临时存起来
				// 把默认文件夹去掉
				var list = this.folder.list.filter(function(item){return item.id});
				list.map(function(item,index){
					folderObj[item.id] = {id:item.id,name: item.name,sort: index +1,remove:true}
				});

				this.folder.cache.map(function(item,index){
					var folder = folderObj[item.id];
					if(folder){
						// 更新
						request.push({operation:"save",id:item.id,name: item.name, sort: index + 1});
						folder.remove = false;
					}else{
						// 新增
						request.push({operation:"save",id:'',name: item.name, sort: index + 1});
					}
				});

				// 删除的
				Object.values(folderObj).map(function(item){
					// 删除
					item.remove && request.push({operation:"delete",id:item.id,name: item.name, sort: request.length + 1});
				});


				this.$ajax('collect_folder_manage', request, function(res) {
					var json = res || {};
					var data = json.data || {}

					this.loading = false;
					
					if (json.code == 200) {

						var records = data.records || [];
						var index = records.map(function(i){return i.id}).indexOf(current.id);

						this.folder.list = records;
						this.folder.show = false;
						
						if(folderObj[current.id] && folderObj[current.id].remove){
							// 如果当前选中的已经被删除，则切换到第一个文件夹
							this.activeSideIndex = 0;
							this.pagesUpdata(true);
						}else if(this.activeSideIndex != index){
							// 如果更换了位置
							this.activeSideIndex = index;
						}

						this.$toast('修改成功');
					} else {
						this.$toast(json.message || '修改失败');
					}
				});
			}
		},

		// 获取分页
		pagesUpdata:function(refresh){
			var that = this;
			var forbiden = that.forbiden.split(',').filter(function(i){return i});


			if(this.nomore && !refresh){return;}
			if(refresh){this.loading = true;}

			this.cache.form.folderId = this.folder.list[this.activeSideIndex].id;

			// 分页调整
			this.cache.form.currentPage = refresh ? 1 : this.cache.form.currentPage + 1;

			// ajax
			this.$ajax('collect_search', this.cache.form, function(response){

				var data = (response || {}).data || {};
				var record = data.records || [];
				var pages = that.cache.pages;
				var outerW = 0;
				


				if(that.$refs.outer){
					outerW = (that.$refs.outer.offsetWidth - 30)/2;
				}else{
					outerW = (window.screen.width - 110)/2;
				}

				// 如果刷新，则清空原数据
				if(refresh){
					pages.length = 0;
					// record.folders.map(function(item,index){
					// 	item.type = 'folder';
					// 	item.height = outerW + 50;
					// 	pages.push(item);
					// });
				}
				record.map(function(item,index){
					var width = parseFloat(item.smallWidth) || 1;
					var height = parseFloat(item.smallHeight) || 1;

					var slope = height / width;
					item.collected = !!item.active;
					item.height = outerW * slope + 50;
					item.paddingBottom = 100 * slope + '%';

					// 禁用的不添加进去
					if(forbiden.indexOf(item.type) >=0 ){
						// 禁用掉了，不给显示
					}else{
						pages.push(item);	
					}
				});

				that.loading = false;				
				that.selectFilter(); // 重置选中的问题
				that.nomore = record.length < that.cache.form.showCount;
				that.nomore && that.$nextTick(function(){that.$refs.scroller && that.$refs.scroller.infiniteComplete();});
			});
		},

		// 取消收藏
		cancelCollect:function(ids){

			var that = this;

			if(!ids){
				ids = this.selected.map(function(i){return i.gId});
			}else if(Object.prototype.toString.call(ids) == '[object Array]'){
				ids = ids;
			}else{
				ids = [ids];
			}

			if(ids.length <=0){
				this.$toast('未选中图片');
			}else{

				this.loading = true;
				this.$ajax('collect_cancel',{gIds : ids.join(',')},function(response){

					var json = response || {};

					if(json.code == 200){
						that.loading = false;
						that.selected.splice(0,that.selected.length);
						that.pagesUpdata(true);
						that.$toast('取消收藏成功');
						that.$emit('global:collect',{gId: ids.join(','), action: 'collect_cancel', form:'collect'});
					}else{
						that.$toast('取消收藏失败');
					}
					
				});
			}
		},


		// 重置选中功能
		selectFilter:function(){

			var that = this;
			var sort = {}
			var selected = this.selected || [];
			var disabled = this.disabled || [];
			var pictures = this.cache.pages.filter(function(i){return i.type != 'folder';});
			
			this.selectall = pictures.length > 0;
			selected.map(function(item,index){sort[item.gId] = index + 1;});
			pictures.map(function(item){
				item.selected = !!sort[item.gId];
				item.disabled = disabled.indexOf(item.gId) >= 0;
				item.selectindex = sort[item.gId] || '';
				that.selectall = item.selected && that.selectall;
			});
		},

		// 点击选中
		selectItem:function(item){

			var selected = this.selected || [];
			var disabled = this.disabled || [];

			if(!item){return;}

			if(!this.selectable){
                this.$toLink('dish_detail.html',{gId:item.gId})
			}else if(disabled.indexOf(item.gId) < 0){

				if(item.selected){
					var index = selected.map(function(i){return i.gId}).indexOf(item.gId);
					if(index <0 ){return;}
					selected.splice(index,1);
				}else {
					selected.push(item);
				}
				this.$emit('selected',item);
				this.selectFilter();
			}
		},
		// 全选或全不选
		// 只选中当前界面中有的项，且原顺序不变
		// 取消全选也只是取消当前界面中的项，其他项不改
		selectAll: function() {

			var sort = {}
			var selected = this.selected;
			selected.map(function(item, index) { sort[item.gId] = index + 1; });

			if (this.selectall) {
				this.cache.pages.map(function(item) {
					sort[item.gId] && selected.splice(selected.map(function(i) { return i.gId }).indexOf(item.gId), 1);
				});
				this.selectFilter();
			} else {
				this.cache.pages.map(function(item) {
					// 别让文件夹参和进来
					if (item.type == 'folder') { return }!sort[item.gId] && selected.push(item);
				});
				this.selectFilter();
			}
		},
		doLogin: function() {
			this.login = true;
			// this.pagesUpdata(true);
			this.getFolderList()
		},


			},
	created: function() {
		var that = this;
		var config = JSON.parse(localStorage.getItem('config') || '{}');

		this.login = (config.user || {}).login;
		// this.cache = this.$root.collectdata || this.cache;
		// this.$root.collectdata = this.cache;
		// this.loading = false;


		if (this.cache.pages.length == 0 && this.login) {
			// this.pagesUpdata(true);
			this.getFolderList()
		} else {
			this.selectFilter();
		}

		this.$on('global:collect', function() { that.pagesUpdata(true); });
		this.$on('global:login', this.doLogin);

	},

});