Vue.component('main-home', {
    style: '.main_home{background:#f00;}',
    template:
        '<div class="main_home">' +
        '<div class="title main_home_title">' +
        '<cite>' +
        // '<form class="main_home_title_search" action="" @submit.prevent="doSearch()">'+
        '<form class="main_home_title_search" action="" @click="doSearch()">' +
        '<input type="search" v-model="keyword" placeholder="搜索美食图片" autocomplete="off"/>' +
        '<button type="submit"><img src="../images/icons/icon_search.png" alt=""></button>' +
        '</form>' +
        '<div class="main_home_scan" @click="checkLinke(\'index_scan.html\',{fromPage:\'index.html\'})">' +
        '<i class="iconfont icon-saoma"></i>' +
        '</div>' +
        '</cite>' +
        '</div>' +
        '<div class="main_warper" ref="warper" v-loading="loading">' +
        '<vue-scroller ref="scroller" :items="cache.pages" :infinite="true" :pulldown="true" :column="2" :margin="16" :spacing="10" @onloadmore="pagesUpdata(false)" @onpullrefresh="pagesUpdata(true)" @onscroll="onscroll" @onscrollstart="onscrollstart" @onscrollend="onscrollend">' +
        '<template slot="prepend">' +
        '<div class="main_home_banner" ref="mainHomeBanner"><div class="swiper-container"><div class="swiper-wrapper"><div class="swiper-slide" v-for="item in banner" :key="item.b_id"><span><img :src="$cache(item.smallUrl)" ></span></div></div><div class="swiper-pagination"></div></div></div>' +
        '<div class="main_home_menu">' +
        '<ul>' +
        '<li @click="$root.mainType(\'search\')"><img src="../images/icons/icon_ms.png" alt=""><span>美食图库</span></li>' +
        '<li @click="$toLink(\'index_company.html\',{referer:\'home\'})"><img src="../images/icons/icon_company.png" alt=""><span>菜谱公司</span></li>' +
        '<li @click="$toLink(\'recipe_list.html\')"><img src="../images/icons/icon_makeRecipe.png" alt=""><span>制作菜谱</span></li>' +
        '<li @click="$toLink(\'lightbox_temp.html\',{type:\'lightbox\'})"><img src="../images/icons/icon_lightbox.png" alt=""><span>制作灯箱片</span></li>' +
        '<li @click="$toLink(\'poster_list.html\',{type:\'poster\'})"><img src="../images/icons/icon_poster.png" alt=""><span>制作海报</span></li>' +
        '<li @click="$toLink(\'yunrecipe_list.html\')"><img src="../images/icons/icon_yunRecipe.png" alt=""><span>制作云菜谱</span></li>' +
        '<li @click="gotoYunscreenList()"><img src="../images/icons/icon_yunScreen.png" alt=""><span>云屏</span></li>' +
        '<li @click="$toast(\'敬请期待...\')"><img src="../images/icons/icon_download.png" alt=""><span>付费下载</span></li>' +
        '</ul>' +
        '</div>' +
        '<div class="main_home_subtitle"><strong>最新菜品推荐</strong><span>实时掌握当季最热卖的菜</span></div>' +
        '</template>' +
        '<template slot="content" slot-scope="props">' +
        '<div class="caipin_warp">' +
        '<h3 @click="$toLink(\'index_subject_detail.html\',{id:props.item.id})" :style="{paddingBottom:props.item.paddingBottom}">' +
        '<img :src="$cache(props.item.smallUrl)">' +
        '</h3>' +
        '<h6>' +
        '<strong v-text="props.item.title"></strong>' +
        '<span v-text="props.item.description"></span>' +
        '</h6>' +
        '</div>' +
        '</template>' +
        '</vue-scroller>' +
        '</div>' +
        '</div>',
    data: function () {
        return {
            keyword: '',
            company: {},
            banner: [],
            cache: { nomore: false, form: { currentPage: 0, showCount: 10 }, pages: [] },
            loading: true,
            scroller: null,

            opacity: 0,
            showTitleForm: true,
        }
    },
    computed: {
        getTitleStyle: function () {
            var range = 255 - 100
            var rgb = 255 - parseInt(this.opacity * range)
            var color = 'rgba(' + [rgb, rgb, rgb, 1].join(',') + ')'

            return { background: 'rgba(255,255,255,' + this.opacity + ')', color: color }
        },
    },
    methods: {
        // 获取数据
        pagesUpdata: function (refresh, callback) {
            var that = this

            if (this.cache.nomore && !refresh) {
                return
            }
            if (refresh) {
                this.loading = true
            }

            // 超哥说：init 接口里面就有第一页的subjects数据，一进来第一页数据就别去请求，但刷新要去请求第一页数据
            var isObject = Object.prototype.toString.call(refresh) === '[object Object]'
            var cb = function (response) {
                var data = response || {}
                var list = data.records || []
                var width = (window.screen.width - 42) / 2
                var pages = that.cache.pages

                // 如果刷新，则清空原数据
                // refresh && pages.splice(0,pages.length);
                refresh === true && pages.splice(0, pages.length)
                list.map(function (item, idx) {
                    var slope = parseFloat(item.smallHeight) / (parseFloat(item.smallWidth) || 1)
                    item.height = width * slope + 78.5
                    item.paddingBottom = 100 * slope + '%'
                    pages.push(item)
                })

                that.loading = false

                that.cache.nomore = list.length < that.cache.form.showCount

                that.cache.nomore &&
                    that.$nextTick(function () {
                        that.$refs.scroller && that.$refs.scroller.infiniteComplete()
                    })
            }

            if (isObject) {
                cb(refresh)
                return
            } else {
                // 分页调整
                this.cache.form.currentPage = refresh ? 1 : this.cache.form.currentPage + 1
                this.$ajax('subject_search', this.cache.form, function (response) {
                    cb((response || {}).data || {})
                })
            }
        },

        setIscroll: function () {
            // 显示滚动条
            if (this.iscroll) {
                return
            } else {
                var width = window.screen.width - 32
                var height = 0.5 * width

                this.swiper = new Swiper('.swiper-container', {
                    loop: true, // 循环模式选项
                    slidesPerView: 'auto',
                    centeredSlides: true,
                    // spaceBetween: 30,

                    // width: width,
                    // height: height,
                    spaceBetween: 16,
                    // centeredSlides:true,
                    // slidesPerView: 'auto',
                    autoplay: { delay: 5000, loop: true, disableOnInteraction: false },
                    pagination: { el: '.swiper-pagination', type: 'bullets' },
                })
            }
        },

        // 搜索
        doSearch: function () {
            var cache = {
                form: { order: 'newest', keywords: '', currentPage: 0, filterid: 0, showCount: 20 },
                filter: [],
                pages: [],
            }
            this.$root.searchdata = this.$root.searchdata || cache
            this.$root.searchdata.form = this.$root.searchdata.form || {}
            this.$root.searchdata.form.keywords = this.keyword

            this.$root.mainType('search', 'autofocusInSearch')
        },

        // 搜索关键字
        searchType: function (type) {
            this.$root.mainType('search')
            this.$nextTick(function () {
                this.$emit('global:search_settype', type)
            })
        },
        // 检查链接
        checkLinke: function (link, option) {
            var config = JSON.parse(localStorage.getItem('config') || '{}')
            var login = (config.user || {}).login
            if (login) {
                link && this.$toLink(link, option)
            } else {
                this.$toLink('index_login.html')
            }
        },

        // 跳转我的云屏
        gotoYunscreenList: function () {
            var config = JSON.parse(localStorage.getItem('config') || '{}')
            var login = (config.user || {}).login
            var deviceList = config.deviceList || []
            if (!login) {
                this.$toLink('index_login.html')
            } else if (deviceList.length >= 1) {
                // 跳到列表
                this.$toLink('yunscreen_list.html')
            } else {
                // 跳到扫码
                this.$toLink('index_scan.html', { fromPage: 'index.html' })
            }
        },

        // 监听滚动
        onscroll: function (iscroll) {
            var bh = 160
            var y = Math.abs(iscroll.y)
            var diff = bh - 160
            if (y < diff) {
                this.opacity = 0
            } else if (y >= diff && y <= bh) {
                this.opacity = (y - diff) / 100
            } else if (y > bh) {
                this.opacity = 1
            }
        },
        onscrollstart: function (iscroll) {
            this.onscroll(iscroll)
        },
        onscrollend: function (iscroll) {
            this.onscroll(iscroll)
        },
    },
    beforeDestroy: function () {
        this.scroller = this.scroller_warper && this.scroller_warper.destroy() && null
        this.swiper = this.swiper && this.swiper.destroy() && null
    },

    mounted: function () {
        var config = this.$root.config || {}

        // 缓存
        this.keyword = ((this.$root.searchdata || {}).form || {}).keywords
        this.company = config.company || {}
        this.banner = config.banner || []
        this.pages = []
        this.cache = this.$root.subjectdata || this.cache
        this.$root.subjectdata = this.cache
        this.loading = false

        if (this.cache.pages.length == 0) {
            var subjects = config.subjects
            var isObject = Object.prototype.toString.call(subjects) == '[object Object]'
            isObject ? this.pagesUpdata(subjects) : this.pagesUpdata(true)
        } else {
            this.cache.nomore &&
                this.$nextTick(function () {
                    this.$refs.scroller.infiniteComplete()
                })
        }
        this.$nextTick(function () {
            this.setIscroll()
        })
    },
})
