Vue.component('main-maker', {
	template: '<div class="main_maker" >' +
		'<div class="title" ><cite><h2>制作</h2></cite></div>' +
		'<div class="main_warper" ref="warper">' +
			'<div class="main_home_inner" >' +
				'<div class="main_maker_title"><strong>菜谱</strong><span>一键生成菜谱，一键改文字畅快做菜谱</span><a @click="$toLink(\'recipe_list.html\')">全部<i class="iconfont icon-xiangyou"></i></a></div>' +
				'<div class="main_maker_recipe" ref="recipe">' +
					'<ul>' +
						'<li v-for="item in recipeList" @click="selectRecipe(item)" :key="item.id">' +
							'<figure :style="item._style"><img :src="$cache(item.thumb)"></figure>' +
						'</li>' +
					'</ul>' +
				'</div>' +
				'<div class="main_maker_title"><strong>灯箱片</strong><span>选尺寸选模板，灯箱片1分钟搞定</span><a @click="checkLink(\'lightbox_temp.html\')">全部<i class="iconfont icon-xiangyou"></i></a></div>' +
				'<div class="main_maker_lightbox" ref="lightbox">' +
					'<ul><li v-for="item in lightboxList" @click="selectLightbox(item)" :key="item.id" :style="item._style"><span v-text="item.name"></span></li></ul>' +
				'</div>' +
				'<div class="main_maker_title"><strong>海报</strong><span>只有最专业的菜品图片，才有最专业的海报</span><a @click="checkLink(\'poster_list.html\')">全部<i class="iconfont icon-xiangyou"></i></a></div>' +
				'<div class="main_maker_poster" ref="poster">' +
					'<ul>' +
						'<li v-for="item in posterList" @click="selectPoster(item)" :key="item.id">' +
							'<figure :style="item._style"><img :src="$cache(item.thumb)"></figure>' +
						'</li>' +
					'</ul>' +
				'</div>' +
				'<div class="main_maker_title"><strong>云菜谱</strong><span>菜谱一键上屏，随时随地更换 </span><a @click="checkLink(\'yunrecipe_list.html\')">全部<i class="iconfont icon-xiangyou"></i></a></div>' +
				'<div class="main_maker_program" ref="program">' +
					'<ul>' +
						'<li v-for="item in programList" @click="selectProgram(item)" :key="item.id">' +
						'<figure :style="item._style"><img :src="$cache(item.thumb)"></figure>' +
						'</li>' +
					'</ul>' +
				'</div>' +
			'</div>' +
		'</div>' +
	'</div>',
	data: function() {
		return {
			lightboxList: [], // 灯箱片列表
			recipeList: [], // 菜谱列表
			posterList: [], // 海报列表  
			programList: [], // 云菜谱列表
			scrollerWaper:null,
			scrollerLightbox:null,
			scrollerRecipe:null,
			scrollerPoster:null,
			scrollerProgram:null,
		}
	},
	methods: {


		// 链接
		checkLink: function(link, option) {

			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var login = (config.user || {}).login;

			if (login) {
				link && this.$toLink(link, option);
			} else {
				this.$toLink('index_login.html');
			}
		},

		// 选中菜谱
		selectRecipe: function(item) {
			if (!item || !item.id) { return; }
			this.$toLink('recipe_detail.html', { id: item.id });
		},

		// 选择海报
		selectPoster: function(item) {

			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var login = (config.user || {}).login;
			var that = this;

			if (!item || !item.id) { return; }
			if (login) {

				// 取数据
				this.$ajax('poster_temp', { id: item.id }, function(response) {
					var json = response || {};
					var template = json.data || {};

					if (json.code == 200) {
						template.width = parseFloat(template.width);
						template.height = parseFloat(template.height);
						template.posterId = template.id; // 用 posterId 来表示海报模版id,
						delete template.id;

						localStorage.setItem('poster_detail', JSON.stringify(template));
						that.$toLink('poster_detail.html');
					} else {
						that.$toast(json.msg || '获取海报模板数据失败');
					}
				});

			} else {
				this.$toLink('index_login.html');
			}
		},

		// 选中灯箱片
		selectLightbox: function(item) {

			var width = parseFloat(item.width) || 30;
			var height = parseFloat(item.height) || 30;
			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var login = (config.user || {}).login;

			if (!login) {
				this.$toLink('index_login.html');
			} else {
				this.$toLink('lightbox_temp.html', { width: width, height: height });
			}
		},

		// 选中云菜谱
		selectProgram: function(item) {

			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var login = (config.user || {}).login;
			if (!login) {
				this.$toLink('index_login.html');
			} else {
				this.$toLink('yunrecipe_detail.html', { id: item.id });
			}
		},
		// 设置滚动
		setScroller:function(){

			// 全局
			if(this.scrollerWaper){
				this.scrollerWaper.refresh()
			}else{
				this.scrollerWaper = new IScroll(this.$refs.warper, {
					scrollbars: true,
					fadeScrollbars: true,
					probeType: 1,
					bounce: true,
					click: false,
					mouseWheel: true,
					mouseWheelSpeed: 1,
					scrollX: false,
					scrollY: true,
				})
			}

			if(this.scrollerRecipe){
				this.scrollerRecipe.refresh()
			}else{
				this.scrollerRecipe = new IScroll(this.$refs.recipe, {
					probeType: 1,
					bounce: true,
					click: false,
					mouseWheel: true,
					mouseWheelSpeed: 1,
					scrollX: true,
					scrollY: false,
				});
			}


			if(this.scrollerLightbox){
				this.scrollerLightbox.refresh()
			}else{
				this.scrollerLightbox = new IScroll(this.$refs.lightbox, {
					probeType: 1,
					bounce: true,
					click: false,
					mouseWheel: true,
					mouseWheelSpeed: 1,
					scrollX: true,
					scrollY: false,
				});
			}

			if(this.scrollerPoster){
				this.scrollerPoster.refresh()
			}else{
				this.scrollerPoster = new IScroll(this.$refs.poster, {
					probeType: 1,
					bounce: true,
					click: false,
					mouseWheel: true,
					mouseWheelSpeed: 1,
					scrollX: true,
					scrollY: false,
				});
			}

			if(this.scrollerProgram){
				this.scrollerProgram.refresh()
			}else{
				this.scrollerProgram = new IScroll(this.$refs.program, {
					probeType: 1,
					bounce: true,
					click: false,
					mouseWheel: true,
					mouseWheelSpeed: 1,
					scrollX: true,
					scrollY: false,
				});
			}

		}

	},
	beforeDestroy: function() {

	},
	mounted: function() {

		var that = this;
		var config = JSON.parse(localStorage.getItem('config') || '{}');

		this.recipeList = (config.recipeList || []).map(function(item) {
			var warph = 126;
			var warpw = warph * (parseInt(item.width) / parseInt(item.height) || 1);
			item._style = 'width:' + warpw + 'px;height:'+ warph +'px;'
			return item;
		});

		this.lightboxList = (config.lightboxCommonSize || []).map(function(item) {
			var warph = 70;
			var warpw = warph * (parseInt(item.width) / parseInt(item.height) || 1);
			item._style = 'width:' + warpw + 'px;height:'+ warph +'px;'
			return item;
		});

		this.posterList = (config.posterList || []).map(function(item) {
			var warph = 126;
			var warpw = warph * (parseInt(item.width) / parseInt(item.height) || 1);
			item._style = 'width:' + warpw + 'px;height:'+ warph +'px;'
			return item;
		});

		this.programList = (config.programList || []).map(function(item) {
			var warph = 126;
			var warpw = warph * (parseInt(item.width) / parseInt(item.height) || 1);
			item._style = 'width:' + warpw + 'px;height:'+ warph +'px;'
			return item;
		});


		this.$nextTick(function(){this.setScroller()})



	}
});