Vue.component('main-search', {
	template: 
	'<div class="search">'+
        '<div class="title main_search_title">'+
            '<cite>'+
                '<form class="main_search_title_search" action="" @submit.prevent="doSearch()">'+
                	'<input id="inputBox" type="search" v-model="cache.form.keywords" placeholder="搜索美食图片" autocomplete="off"/>'+
                    '<button type="submit"><img src="../images/icons/icon_search.png" alt=""></button>'+
                '</form>'+
            '</cite>'+
        '</div>'+
		'<div class="search_nav">'+
			'<ul>'+
				'<li @click="setType(\'company\')" :class="{active: cache.form.sellerId}" ><i class="iconfont icon-guquanxieyi"></i>菜谱公司</li>'+
				'<li @click="setType(\'newest\')" :class="{active: !cache.form.sellerId && cache.form.order==\'newest\'}"><i class="iconfont icon-tubiaozuixin01"></i>最新上传</li>'+
				'<li @click="setType(\'hotest\')" :class="{active: !cache.form.sellerId && cache.form.order==\'hotest\'}"><i class="iconfont icon-huo"></i>最具人气</li>'+
				'<li @click="setType(\'filter\')" :class="{active: cache.form.type || cache.form.cuisineId || cache.form.methodId || cache.form.material }"><i class="iconfont icon-shaixuan"></i>详细分类</li>'+
				// '<li @click="showActionsAll=true" class="search_nav_all">全部</li>'+
			'</ul>'+
		'</div>'+
		'<div class="search_list" v-loading="loading">'+
			'<vue-scroller v-if="cache.pages.length>0"'+
				'ref="scroller"'+
				':items="cache.pages" '+
				':infinite="true" '+
				':pulldown="true" '+
				':column="2"'+ 
				':margin="16" '+
				':spacing="10" '+
				'@onloadmore="pagesUpdata(false)" '+
				'@onpullrefresh="pagesUpdata(true)"'+
			'>'+
				'<template slot="content" slot-scope="props">'+
					'<div class="search_item" :class="{selected: selectable && props.item.selected, disabled: selectable && props.item.disabled}">'+
						'<figure class="search_item_imgBox" @click="selectItem(props.item)" :style="{paddingBottom: props.item.paddingBottom}">'+
							'<img :src="$cache(props.item.smallUrl)" >'+
                            '<strong><span><i class="iconfont icon-shoucang"></i><em v-text="props.item.collectTimes || 0"></em></span></strong>'+
                            '<div class="search_item_num"><em v-text="props.item.galleryNum + \' \'"></em>图</div>'+
                            '<i v-if="props.item.type == \'video\'" class="iconfont icon-play"></i>'+
						'</figure>'+
                        '<div class="search_item_info">'+
                            '<p>'+
                                '<strong v-text="props.item.name"></strong>'+
                                '<label v-if="selectable" style="height:13px"></label>'+
                                '<label v-else>'+
                                    '<span><i class="iconfont icon-liulan"></i><em v-text="props.item.views || 0"></em></span>'+
                                    '<span><i class="iconfont icon-yishou"></i><em v-text="props.item.useTimes || 0"></em></span>'+
                                '</label>'+
                            '</p>'+
                            '<h5 v-if="!selectable" @click="collectPicture(props.item)" :class="{active:props.item.collected}">'+
                                '<i v-if="props.item.collected" class="iconfont icon-yishoucang"></i>'+
                                '<i v-else class="iconfont icon-shoucangHui"></i>'+
                                '<span v-text="props.item.collected ? \'已收藏\' : \'收藏\'"></span>'+
                            '</h5>'+
                        '</div>'+
						'<h6 v-show="selectable" @click="selectItem(props.item)"><i v-text="props.item.selectindex"></i></h6>'+
					'</div>'+
				'</template>'+
			'</vue-scroller>'+
			'<div class="scroller-nodata" v-show="!loading && (!cache.pages || cache.pages.length == 0)" >'+
				'<p>'+
					'<i class="iconfont icon-wushuju"></i>'+
					'<strong v-text="cache.form.type==1 ? \'暂无图片\' : cache.form.type==2 ? \'暂无视频\' : \'暂无图片或视频\'"></strong>'+
					'<span>(试试其他关键词吧)</span>'+
				'</p>'+
	        '</div>'+
		'</div>'+
		
        '<van-action-sheet close-on-click-action v-model="showActionsAll" :actions="actionsAll" @select="onSelectAll"></van-action-sheet>'+
	'</div>', 
	props: {
		selectable: {type: Boolean,default: false},
		selected: {type: Array,default: []},
		disabled: {type: Array,default: []},
		forbiden: {type: String,default: ''},
        autofocusInSearch: {type: Boolean,default: false}, // 用于进到此组件搜索框自动获取焦点
	},
	data:function() {
		return {
			loading:true,
			nomore:false,
			share:null,
			cache: {
				form: {order: 'newest',keywords: '',currentPage: 0,showCount: 20},
				filter: [],
				pages: []
            },
        
            showActionsAll: false,
            actionsAll: [{ id:1, name: '全部' }, { id:2,name: '只看图片' }, { id:3,name: '只看视频' }],
		}
	},
	
	methods: {

		// 获取分页
		pagesUpdata:function(refresh,callback){


			var that = this;
			// 首页是菜品搜索，选择图片的时候，是图片搜索
			var urltype = this.selectable ? 'gallery_search' : 'dish_search';
			var forbiden = this.forbiden.split(',').filter(function(i){return i});

			if(this.nomore && !refresh){return;}
			if(refresh){this.loading = true;}


			// 分页调整
			this.cache.form.currentPage = refresh ? 1 : this.cache.form.currentPage + 1;
			
			this.$ajax(urltype, this.cache.form, function(response){

				var data = (response || {}).data || {};
				var list = data.records || [];				
				var width = (window.screen.width - 42)/2;
				var pages = that.cache.pages;
				var offset = that.selectable ? 30 : 60;

				// 如果刷新，则清空原数据
				refresh && pages.splice(0,pages.length);
				list.map(function(item,idx){

					var imgw = parseFloat(item.smallWidth) || 1;
					var imgh = parseFloat(item.smallHeight) || 1;
					var slope =  imgh / imgw;

					item.collected = !!item.collectStatus;
					item.height = width * slope + offset;
					item.paddingBottom = 100 * slope + '%';
					
					// 禁用的不添加进去
					if(forbiden.indexOf(item.type) >=0 ){
						// 禁用掉了，不给显示
					}else{
						pages.push(item);	
					}
				});

				that.loading = false;
				that.nomore = list.length < that.cache.form.showCount;
				that.nomore && that.$nextTick(function(){that.$refs.scroller && that.$refs.scroller.infiniteComplete();});
				list.length > 0 && that.selectFilter();

			});
		},

		
		// 筛选
		doFilter:function(key,id,name){

			var that = this;

			this.cache.form.keywords = '';
			this.cache.form.order = 'newest';
			this.$delete(this.cache.form,'cuisineId');
			this.$delete(this.cache.form,'methodId');
			this.$delete(this.cache.form,'material');
			this.$delete(this.cache.form,'sellerId');

			this.cache.form[key] = key == "material" ? name : id;
			this.loading = true;
			this.pagesUpdata(true);
		},

		// 选择菜谱公司
		doCompany:function(sellerId){
			
			this.cache.form.keywords = '';
			this.cache.form.order = 'newest';
			this.$delete(this.cache.form,'cuisineId');
			this.$delete(this.cache.form,'methodId');
			this.$delete(this.cache.form,'material');

			if(sellerId){
				this.cache.form.sellerId = sellerId;
			}else{
				this.$delete(this.cache.form,'sellerId');
			}

			this.loading = true;
			this.pagesUpdata(true);
		},

		// 搜索提交
		doSearch:function(){
			document.activeElement.blur();

			this.cache.form.order = 'newest';
			this.$delete(this.cache.form,'cuisineId');
			this.$delete(this.cache.form,'methodId');
			this.$delete(this.cache.form,'material');
			this.$delete(this.cache.form,'sellerId');
			this.pagesUpdata(true);
		},

		// 切换分类
		setType:function(type){

			type = ['company','newest','hotest','filter'].indexOf(type) >= 0 ? type : 'newest';
			if(type == 'filter'){
				this.$toLink('index_search_filter.html',this.cache.form);
			}else if(type == 'company'){
				this.$toLink('index_company.html',this.cache.form);
			}else if(this.cache.form.type != type){
				var that = this;
				this.cache.form.keywords = '';
				this.$delete(this.cache.form,'cuisineId');
				this.$delete(this.cache.form,'methodId');
				this.$delete(this.cache.form,'material');
				this.$delete(this.cache.form,'sellerId');
				this.cache.form.order = type;
				this.pagesUpdata(true);
			}
		},

		// 重置选中功能
		selectFilter:function(){

			var that = this;
			var sort = {}
			var selected = this.selected || [];
			var disabled = this.disabled || [];
			var forbiden = this.forbiden || '';
			var pictures = this.cache.pages;

			selected.map(function(item,index){sort[item.gId] = index + 1;});
			pictures.map(function(item){

				var disa = disabled.indexOf(item.gId) >= 0 || forbiden.indexOf(item.type) >=0;

				that.$set(item,'selected',!!sort[item.gId]);
				that.$set(item,'disabled',disa);
				that.$set(item,'selectindex',sort[item.gId] || '');
			});

		},

		// 点击选中
		selectItem:function(item){

			var selected = this.selected || [];
			var disabled = this.disabled || [];

			if(!item){return;}

			if(!this.selectable){
				// this.previewPicture(item);
                this.$toLink('dish_detail.html',{gId:item.gId});
			}else if(disabled.indexOf(item.gId) < 0){

				if(item.selected){
					var index = selected.map(function(i){return i.gId}).indexOf(item.gId);
					if(index <0 ){return;}
					selected.splice(index,1);
				}else {
					selected.push(item);
				}
				this.$emit('selected',item);
				this.selectFilter();
			}
		},

		// 收藏
		collectPicture:function(item){

			var that = this;
			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var login = (config.user || {}).login;
			var urltype = item.collected ? 'collect_cancel' : 'collect_active';

			if(this.selectable){
				// this.selectItem(item);
			}else if(login){
				// 如果未登录，则先提示登录
				this.loading = true;
				this.$ajax(urltype,{gId:item.gId},function(response){

					var json = response || {};

					if(json.code == 200){
						that.loading = false;
						// that.$set(item,'collected',urltype == 'collect_active');
						that.$toast(json.message || (urltype == 'collect_active' ? '收藏成功':'取消收藏成功'));
						that.$emit('global:collect',{gId: item.gId, action: urltype, form: 'picture'});
					}else{
						that.loading = false;
						that.$toast(json.message || (urltype == 'collect_active' ? '收藏失败':'取消收藏失败'));
					}
				});
			}else{
				this.$toLink('index_login.html');
			}
		},


		// 分享
		sharePicture:function(item){

			if(!item){return;}
			if(this.selectable){return;}
			this.$root.share = item;

		},

		// 显示图片详情
		previewPicture:function(item){

			if(!item){return;}
			if(this.disabled.indexOf(item.gId) >=0 ){return;}
			this.$root.preview = {list: this.cache.pages, item:item, selectable:this.selectable, more:this.pagesUpdata.bind(this)}

        },
        
        // 选择 全部 
        onSelectAll:function(opt){

            // this.cache.pages = this.cache.pages.filter(item=>item.gId==='216941');
        },
	
	},
	created: function() {

		var that = this;

		// this.cache = this.$root.searchdata || this.cache;
		// this.$root.searchdata = this.cache;

		if(this.cache.pages.length ==0 ){
			this.pagesUpdata(true);
		}else{
			this.loading = false;
			this.selectFilter();
		}

		// 有收藏或取消收藏时,更新收藏数据
		this.$on('global:search_filter',function(form){that.doFilter(form.key,form.id,form.name);});
		this.$on('global:search_compay',function(form){that.doCompany(form.sellerId);});
		this.$on('global:search_settype',function(type){that.setType(type);});

		this.$on('global:collect',function(opt){
            that.cache.pages.map(function(item){
                if(item.gId == opt.gId){
                    item.collected = opt.action == 'collect_active' ? true :false;
                }
            })
        });

	},
    mounted:function(){
        var that = this;
        setTimeout(function(){ 
            that.autofocusInSearch && document.getElementById("inputBox").focus(); 
            that.$root.autofocusInSearch = false;
        },100)
    }

});

