Vue.component('main-upload', {
	template: 
	'<div class="main_upload">'+
		'<div class="title">'+
			'<cite>'+
				'<a class="title_toback" @click="$toBack"><i class="iconfont icon-fanhui"></i></a>'+
				'<h2>我的上传</h2>'+
			'</cite>'+
		'</div>'+
		'<div class="main_collect_login" v-show="!login" style="display: none;">'+
			'<p>'+
				'<i class="iconfont icon-ku"></i>'+
				'<strong>您还未登录</strong>'+
				'<span>(请先登录再查看您上传的图片)</span>'+
				'<a @click="$toLink(\'index_login.html\')">点我登录</a>'+
			'</p>'+
		'</div>'+
		'<div class="main_upload_warper" v-if="login" v-loading="loading">'+
			'<div class="main_upload_notify">'+
				'<i class="iconfont icon-zhuyi"></i>'+
				'<p>图片或视频须大于1000像素<br/>您须拥有图片自主版权，盗版自负</p>'+
				'<a @click="fileButtonClick($event)">上传图片、视频</a>'+
				'<input type="file" id="main_upload_file" multiple="multiple" />'+
			'</div>'+
			'<vue-scroller ref="scroller" v-if="pages.length>0"'+
				':items="pages" '+
				':infinite="true" '+
				':pulldown="true" '+
				':column="2"'+ 
				':margin="16" '+
				':spacing="10" '+
				'@onloadmore="pagesUpdata(false)" '+
				'@onpullrefresh="pagesUpdata(true)"'+			
			'>'+
				'<template slot="prepend" ><div style="height:5px"></div></template>'+
				'<template slot="append" ><div style="height:20px"></div></template>'+
				'<template slot="content" slot-scope="props">'+
					'<div class="main_upload_block" :class="{selected: selectable && props.item.selected, disabled: selectable && props.item.disabled}" @click="selectItem(props.item)">'+
						'<figure @click="previewMedia(props.item)" :style="{paddingBottom: props.item.paddingBottom}">'+
							'<img v-if="props.item.gId && props.item.type == \'image\'" :src="$cache(props.item.smallUrl,\'IMAGE\')" />'+
							'<video v-else-if="props.item.gId && props.item.type == \'video\'" :src="$cache(props.item.middleUrl,\'IMAGE\')" :poster="$cache(props.item.smallUrl,\'IMAGE\')" controls="controls" x5-video-player-type="h5" x5-video-player-fullscreen="true" x5-video-orientation="portraint" x5-playsinline="false" playsinline="false" webkit-playsinline="false" x-webkit-airplay="allow" />'+
							'<img v-else-if="props.item.type == \'image\'" :src="props.item.uploadUrl" />'+
							'<video v-else-if="props.item.type == \'video\'" :src="props.item.uploadUrl" controls="controls"  x5-video-player-type="h5" x5-video-player-fullscreen="true" x5-video-orientation="portraint" x5-playsinline="false" playsinline="false" webkit-playsinline="false" x-webkit-airplay="allow" />'+
							'<cite v-show="!props.item.gId" style="display:none"><strong>{{\'上传进度\' + props.item.percent + \'%\'}}</strong><span><em :style="{width: props.item.percent + \'%\'}"></em></span></cite>'+
						'</figure>'+
						'<p v-text="props.item.name"></p>'+
						'<h6 v-show="selectable"><i v-text="props.item.selectindex"></i></h6>'+
					'</div>'+
				'</template>'+
			'</vue-scroller>'+
			'<div class="scroller-nodata" v-show="!loading && (!pages || pages.length == 0)" >'+
				'<p>'+
					'<i class="iconfont icon-wushuju"></i>'+
					'<strong>暂无图片</strong>'+
					'<span>(点击『上传图片』开始上传吧)</span>'+
				'</p>'+
			'</div>'+
			'<div class="main_collect_select" v-show="selectable" style="display: none;">'+
				'<span @click="selectAll()" :class="{active:selectall}"><i class="iconfont icon-checkboxselect"></i><em></em></span>'+
				'<strong>已经选中{{selected.length}}张图片</strong>'+
				'<a @click="removeItem()"><em>删除图片</em></a>'+
			'</div>'+
		'</div>'+
	'</div>',
	props: {
		selectable: {type: Boolean,default: false},
		selected: {type: Array,default: []},
		disabled: {type: Array,default: []},
		forbiden: {type: String,default: ''},
	},
	data:function() {
		return {
			loading:true,
			login:false,
			form: {currentPage:0,showCount:30},
			pages: [],
			uploads: [],
			nomore: false,
			selectall: false,
		}
	},
	methods: {
		
		// 获取分页
		pagesUpdata:function(refresh,callback){

			var that = this;
			var forbiden = this.forbiden.split(',').filter(function(i){return i});

			if(this.nomore && !refresh){return;}
			if(refresh){this.loading = true;}

			// 分页调整
			this.form.currentPage = refresh ? 1 : this.form.currentPage + 1;

			// ajax
			this.$ajax('upload_search', this.form, function(response){

				var data = (response || {}).data || {};
				var list = data.records || [];	
				var width = (window.screen.width - 42)/2;
				var pages = that.pages;

				// 如果刷新，则清空原数据
				refresh && pages.splice(0,pages.length);
				list.map(function(item,idx){

					item.height = width * parseInt(item.smallHeight) / parseInt(item.smallWidth) + 40;
					item.paddingBottom = 100*parseInt(item.smallHeight)/parseInt(item.smallWidth) + '%';
					// 禁用的不添加进去
					if(forbiden.indexOf(item.type) >=0 ){
						// 禁用掉了，不给显示
					}else{
						pages.push(item);	
					}
				});

				that.loading = false;
				that.nomore = list.length < that.form.showCount;
				that.nomore && that.$nextTick(function(){that.$refs.scroller && that.$refs.scroller.infiniteComplete();});
				list.length > 0 && that.selectFilter();

			});
		},

		// 删除图片
		removeItem:function(item){
			var that = this;

			this.$confirm('删除图片将不可恢复，确定删除吗',['暂不删除','确定删除'],function(value){
				if(value != '确定删除'){return;}
				var gId = that.selected.map(function(i){return i.gId});

				that.$ajax('upload_remove',{gId: gId.join(',') ,type:'all'},function(response){
					var json = response || {};
					var data = json.data || [];
					if(json.code == 200){
						that.selected.map(function(item){that.pages.splice(that.pages.indexOf(item),1);});
						that.nomore && that.$nextTick(function(){that.$refs.scroller && that.$refs.scroller.infiniteComplete();});
						that.selectFilter();
						that.$toast('删除图片成功');
					}else{
						that.$toast(json.message || '删除图片失败');
					}
				});
			});
		},

		// 重置选中功能
		selectFilter:function(){

			var that = this;
			var sort = {}
			var selected = this.selected || [];
			var disabled = this.disabled || [];
			var pictures = this.pages;

			this.selectall = pictures.length > 0;
			selected.map(function(item,index){sort[item.gId] = index + 1;});
			pictures.map(function(item){
				that.$set(item,'selected',!!sort[item.gId]);
				that.$set(item,'disabled',disabled.indexOf(item.gId) >= 0);
				that.$set(item,'selectindex',sort[item.gId] || '');
				that.selectall = item.selected && that.selectall;
			});
		},

		// 点击选中
		selectItem:function(item){

			var selected = this.selected || [];
			var disabled = this.disabled || [];

			if(!item){return;}
			if(!item.gId){return;}

			if(!this.selectable){
				// this.previewMedia(item);
			}else if(disabled.indexOf(item.gId) < 0){

				if(item.selected){
					var index = selected.map(function(i){return i.gId}).indexOf(item.gId);
					if(index <0 ){return;}
					selected.splice(index,1);
				}else {
					selected.push(item);
				}
				this.$emit('selected',item);
				this.selectFilter();
			}
		},
		// 全选或全不选
		// 只选中当前界面中有的项，且原顺序不变
		// 取消全选也只是取消当前界面中的项，其他项不改
		selectAll:function(){

			var sort = {}
			var selected = this.selected;
			selected.map(function(item,index){sort[item.gId] = index + 1;});

			if(this.selectall){
				this.pages.map(function(item){
					sort[item.gId] && selected.splice(selected.map(function(i){return i.gId}).indexOf(item.gId),1);
				});
				this.selectFilter();
			}else{
				this.pages.map(function(item){
					!sort[item.gId] && selected.push(item);
				});
				this.selectFilter();
			}
		},

		// 大图预览
		previewMedia:function (item) {
			// if(!item){return;}
			// if(this.disabled.indexOf(item.gId) >=0 ){return;}
			// this.$root.preview = {list: this.pages, item:item, selectable: this.selectable, more:this.pagesUpdata.bind(this)}
		},

		// 文件上传
		mediaUpload : function(item){

			var that = this;
			var request = {
				type: item.type,
				width: item.smallWidth,
				height: item.smallHeight,
				file: item.file,
			}

			this.$ajax('upload_upload',request,function(response){

				var json = response || {};
				var data = (json.data || [])[0] || {};

				if(json.code == 200){
					item.percent = 100;
					item.file = null;
					item.gId = data.gId || item.gId;
					item.name = data.name || item.name;
					item.type = data.type || item.type;
					item.smallUrl = data.smallUrl || item.smallUrl;
					item.middleUrl = data.middleUrl || item.middleUrl;
					item.smallWidth = data.smallWidth || item.smallWidth;
					item.smallHeight = data.smallHeight || item.smallHeight;
					item.middleWidth = data.middleWidth || item.middleWidth;
					item.middleHeight = data.middleHeight || item.middleHeight;

					// 如果是选择，则默认选中
					// that.selectable && that.selectItem(item);
					// that.mediaUpload();
					// that.$toast('上传图片'+ item.name +'成功');
					that.$toast('上传成功');
				}else{
					//that.$toast('上传图片'+ item.name +'失败');
					that.$toast('上传失败');
				}
			},function(event){
				if (event.lengthComputable) {
					item.percent = Math.floor(event.loaded / event.total * 100);
				}
			});
		},

		// 插入数据到用户列表中
		insertMediaToList:function(item,callback){

			var that = this;
			var request = {
				name: item.name,
				type: item.type,
				
				smallUrl: item.smallUrl,
				smallWidth: item.smallWidth,
				smallHeight: item.smallHeight,
				
				middleUrl: item.middleUrl,
				middleWidth: item.middleWidth,
				middleHeight: item.middleHeight,

				originUrl: item.originUrl,
				originWidth: item.originWidth,
				originHeight: item.originHeight,
				
			}

			this.$ajax('upload_insert',request,function(response){

				var json = response || {};
				var data = json.data || {};

				if(json.code == 200){

					item.gId = data.gId;

					delete item.percent;
					delete item.url;
					delete item.file;
					delete item.uploadUrl;
					delete item.uploadWidth;
					delete item.uploadHeight;

					delete item.originUrl;
					delete item.originWidth;
					delete item.originHeight;


					// 如果是选择，则默认选中
					// that.selectable && that.selectItem(item);
					// that.mediaUpload();
					// that.$toast('上传图片'+ item.name +'成功');
					that.$toast('上传成功');
				
				}else{
					//that.$toast('上传图片'+ item.name +'失败');
					that.$toast('上传失败');
				}
			});

		},

		// 插入图片
		mediaInsert:function(file){

			var that = this;

			var insert = function(option){

				var width = (window.screen.width - 30)/2;
				var item = {
					gId: '',
					percent: 0,
					type: option.type,
					name: option.file.name,
					url: option.preview.src,
					file: option.file,
					uploadUrl: option.preview.src,
					uploadWidth: option.width,
					uploadHeight: option.height,

					height: width * parseInt(option.height) / parseInt(option.width) + 40,
					paddingBottom: 100*parseInt(option.height)/parseInt(option.width) + '%',
				}

				// 先把图片插入列表中占位
				that.pages.unshift(item);
				that.nomore && that.$nextTick(function(){that.$refs.scroller.infiniteComplete();});


				if(option.type == 'image'){
					// 如果是图片，就只上传图片
					that.$upload({
						type: 'image',
						file: option.file, 
						width: option.width,
						height: option.height,
						name: option.file.name,
					},function(response) {

						var json = response || {};
						var data = json.data || {};

						if(json.code == 100){
							// 正在上传中
							item.percent = json.percent;
						}else if(json.code == 200){
							// 上传成功
							item.smallUrl = data.smallUrl;
							item.smallWidth = data.smallWidth;
							item.smallHeight = data.smallHeight;

							item.middleUrl = data.middleUrl;
							item.middleWidth = data.middleWidth;
							item.middleHeight = data.middleHeight;

							item.originUrl = data.originUrl;
							item.originWidth = data.originWidth;
							item.originHeight = data.originHeight;

							that.insertMediaToList(item);
						}else{
							// 上传失败
							that.$toast('上传失败');
							that.selected.map(function(item){that.pages.splice(that.pages.indexOf(item),1);});
							that.nomore && that.$nextTick(function(){that.$refs.scroller.infiniteComplete();});
						}
					})

				}else if(option.type == 'video'){

					// 如果是视频，则先上传封面，再上传视频

					var canvas = document.createElement("canvas");
					var uploadOver = {video:false,image:false}
					var uploadReady = function(){

						if(uploadOver.video && uploadOver.image){
							if(item.smallUrl && item.middleUrl){
								// 上传成功
								that.insertMediaToList(item);	
							}else{
								// 上传失败
								that.$toast('上传失败');
								that.selected.map(function(item){that.pages.splice(that.pages.indexOf(item),1);});
								that.nomore && that.$nextTick(function(){
									that.$refs.scroller && that.$refs.scroller.infiniteComplete();
								});
							}
						}
					}
					
					canvas.name = (option.file.name || '').replace(/\.[\w\W]*?$/,'') + '.png';
					canvas.width = option.width;
					canvas.height = option.height;
					canvas.getContext("2d").drawImage(video, 0, 0, canvas.width, canvas.height);

					// 上传封面
					that.$uploadCanvas(canvas, function(imageUrl) {
						if (imageUrl) {
							// 上传封面成功
							item.smallUrl = imageUrl;
							item.smallWidth = canvas.width;
							item.smallHeight = canvas.height;
							uploadOver.image = true;
							uploadReady();
						}else {
							uploadOver.image = true;
							uploadReady();
						}
					});

					// 上传视频
					that.$upload({
						type: 'video',
						file: option.file, 
						width: option.width,
						height: option.height,
						name: option.file.name,
					}, function(response) {

						var json = response || {};
						var data = json.data || {};

						if(json.code == 100){
							// 正在上传中
							item.percent = json.percent;
						}else if(json.code == 200){
							// 上传成功
							item.middleUrl = data.middleUrl;
							item.middleWidth = data.middleWidth;
							item.middleHeight = data.middleHeight;

							item.originUrl = data.originUrl;
							item.originWidth = data.originWidth;
							item.originHeight = data.originHeight;

							uploadOver.video = true;
							uploadReady();
						}else {
							uploadOver.video = true;
							uploadReady();
						}

					})

				}
			}
			

			if(file.type.indexOf('image') >= 0){

				var reader = new FileReader();
				var img = new Image();

				img.onload = function() {
					insert({
						type:'image',
						width:img.width,
						height:img.height,
						preview: img,
						file: file,
					});
				}
				reader.onload = function(){img.src = this.result;};
				reader.readAsDataURL(file);

			}else if(file.type.indexOf('video') >= 0){

				var reader = new FileReader();
				var video = document.createElement("video");

				video.onerror = function(){
					that.$toast('视频加载出错')
				};
				video.onloadeddata = function(){
					insert({
						type: 'video',
						width: video.videoWidth,
						height: video.videoHeight,
						preview: video,
						duration: video.duration,
						file: file,
					});
				}

				// 获取视频封面
				reader.onload = function(){
					video.setAttribute('crossOrigin', 'anonymous');//处理跨域
					video.setAttribute("preload", 'preload'); // 设置为meta貌似无效    复制代码        video.src = e.target.result
					video.setAttribute("muted", 'muted');
					video.setAttribute("autoplay", 'autoplay');
					video.setAttribute('src', this.result);
				};
				reader.readAsDataURL(file);
			}

		},

		// 路径转为file对象
		mediaPathToFile:function(pathname,filename){

			var that = this;
			var reader = new plus.io.FileReader();
			reader.onloadend = function(e) {
				// data:image/jpeg;base64,/9j/4SYjRXhpZgAATU0......
				var base64 = e.target.result; //base64图片                         
				var arr = base64.split(',')
				var mime = arr[0].match(/:(.*?);/)[1];
				var bstr = window.atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
				while(n--){u8arr[n] = bstr.charCodeAt(n);}

				that.mediaInsert(new File([u8arr], filename, {type:mime}));
			};
			reader.readAsDataURL(pathname);
		},

		// 选择图片
		fileButtonClick:function(event){

			var that = this;

			if(window.plus){

				window.plus.nativeUI.actionSheet({
					title:"选择照片",
					cancel:"取消",
					buttons:[
						{title:"拍照"},
						{title:"从相册中选取"}
					]
				}, function(e){

					if(e.index == 1){
						// 拍照上传
						// 视频拍摄不大好搞
						window.plus.camera.getCamera().captureImage(function(path){
							// /storage/emulated/0/Android/data/io.dcloud.HBuilder/apps/HBuilder/doc/1546789926151.jpg
							var filename = path.replace(/(.*\/)*([^.]+.*)/ig,"$2");
							var pathname = plus.io.convertLocalFileSystemURL(path);
							that.mediaPathToFile(pathname,filename);
						});
					}else if(e.index == 2){
						// 从相册中选择
						window.plus.gallery.pick(function(result){
							Array.prototype.slice.call(result.files).map(function(path){
								// file:///storage/emulated/0/MagazineUnlock/magazine-unlock-hi2150203.jpg
								var filename = path.replace(/(.*\/)*([^.]+.*)/ig,"$2");
								var pathname = path.replace('file://','');
								that.mediaPathToFile(pathname,filename);
							});
						}, null, {
							filter: "none",
							multiple: true,
							maximum: 5,
							system: false
						});
					}
				});
			}else{
				var input = document.getElementById('main_upload_file');
				event.stopPropagation();
				event.preventDefault();
				input.click();
				input.onchange = function(){
					Array.prototype.slice.call(this.files).map(function(file){
						that.mediaInsert(file);
					})
				}
			}
		},
		doLogin:function(){
			this.login = true;
			this.pagesUpdata(true);
		},
	},
	created: function() {
		var config = JSON.parse(localStorage.getItem('config') || '{}');

		this.login = (config.user || {}).login;
		this.login && this.pagesUpdata(true);
		this.$on('global:login',this.doLogin);
	}
});

