Vue.component('main-user', {
    template:
        '<div class="main_user">' +
        '<div class="main_user_background"></div>' +
        '<vue-scroller :items="[]" :infinite="false" :pulldown="false">' +
        '<template slot="prepend" >' +
        '<div class="main_user_header">' +
        '<div class="main_user_header_do">' +
        '<div @click="$toLink(\'user_setting.html\')" class="main_user_header_setting"><i class="iconfont icon-shezhi1"></i></div>' +
        '<div @click="$toLink(\'user_share.html\')" class="main_user_header_share"><i class="iconfont icon-fenxiang1"></i></div>' +
        '</div>' +
        '<div class="main_user_header_headimg">' +
        '<img @click="checkLink(null)" class="js-headimg" :src="user.login ? user.headimgurl : \'../images/headimg.png\'">' +
        '<span v-html="user.login ? user.nickname : \'未登录\'"></span>' +
        '</div>' +
        '<div class="main_user_header_order">' +
        '<h4 @click="checkLink(\'user_order.html\')"><span>我的订单</span></h4>' +
        '<p>' +
        "<a @click=\"checkLink('user_order.html',{type:'0'})\">" +
        '<img src="../images/icons/icon_waitPay.png" alt="">' +
        '<span>待付款</span>' +
        '</a>' +
        "<a @click=\"checkLink('user_order.html',{type:'1'})\">" +
        '<img src="../images/icons/icon_waitSend.png" alt="">' +
        '<span>待发货</span>' +
        '</a>' +
        "<a @click=\"checkLink('user_order.html',{type:'2'})\">" +
        '<img src="../images/icons/icon_waitRecieve.png" alt="">' +
        '<span>待收货</span>' +
        '</a>' +
        "<a @click=\"checkLink('user_order.html',{type:'3'})\">" +
        '<img src="../images/icons/icon_done.png" alt="">' +
        '<span>已完成</span>' +
        '</a>' +
        '</p>' +
        '</div>' +
        '</div>' +
        '<div class="main_user_entrance">' +
        '<a @click="checkLink(\'recipe_record.html\')" class="main_user_entrance_item">' +
        '<i class="iconfont icon-wodecaipu"></i>' +
        '<span>我的菜谱</span>' +
        '</a>' +
        '<a @click="checkLink(\'lightbox_record.html\')" class="main_user_entrance_item">' +
        '<i class="iconfont icon-wodedengxiangpian"></i>' +
        '<span>我的灯箱片</span>' +
        '</a>' +
        '<a @click="checkLink(\'poster_record.html\')" class="main_user_entrance_item">' +
        '<i class="iconfont icon-wodehaibao"></i>' +
        '<span>我的海报 </span>' +
        '</a>' +
        '<a @click="checkLink(\'yunprogram_list.html\')" class="main_user_entrance_item">' +
        '<i class="iconfont icon-yunping"></i>' +
        '<span>我的云菜谱</span>' +
        '</a>' +
        '</div>' +
        '<ul>' +
        '<li @click="gotoYunscreenList()"><i class="iconfont icon-wodeguanggaoping"></i><span>我的云屏</span></li>' +
        '<li @click="checkLink(\'user_upload.html\')"><i class="iconfont icon-woshangchuandetupian"></i><span>我的上传</span></li>' +
        '<li @click="checkLink(\'user_address.html\')"><i class="iconfont icon-shouhuodizhi"></i><span>我的收货地址</span></li>' +
        '</ul>' +
        '<ul>' +
        '<li @click="checkLink(\'user_setting_feedback.html\')"><i class="iconfont icon-yijianfankui1"></i><span>意见反馈</span></li>' +
        '<li><a @click="callTo($event,company.phone)"><i class="iconfont icon-yijianfankuibeifen"></i><span>联系客服（{{company.phone || \'\'}}）</span></a></li>' +
        '</ul>' +
        '<h6 @click="loginTrigger()" v-text="user.login ? \'退出登录\' : \'立即登录\'"></h6>' +
        '<div style="height:10px"></div>' +
        '</template>' +
        '</vue-scroller>' +
        '</div>',
    data: function () {
        return {
            user: {},
            company: {},
            config: {},
        }
    },
    methods: {
        // 登录或退出
        loginTrigger: function () {
            if (this.user.login) {
                var that = this
                this.$confirm('确定要退出登录吗？', ['确定退出', '先不退出'], function (value) {
                    if (value != '确定退出') {
                        return
                    }
                    that.$emit('global:quit', null)
                })
            } else {
                this.$toLink('index_login.html')
            }
        },

        // 链接
        checkLink: function (link, option) {
            if (this.user.login) {
                link && this.$toLink(link, option)
            } else {
                this.$toLink('index_login.html')
            }
        },

        // 跳转我的云屏
        gotoYunscreenList: function () {
            var config = JSON.parse(localStorage.getItem('config') || '{}')
            var login = (config.user || {}).login
            var deviceList = config.deviceList || []
            if (!login) {
                this.$toLink('index_login.html')
            } else if (deviceList.length >= 1) {
                // 跳到列表
                this.$toLink('yunscreen_list.html')
            } else {
                // 跳到扫码
                this.$toLink('index_scan.html', { fromPage: 'index.html' })
            }
        },

        // 拨打电话
        callTo: function (event, number) {
            if (window.plus) {
                window.plus.device.dial(number, true)
                event.stopPropagation()
            } else {
                event.currentTarget.setAttribute('href', 'tel:' + number)
            }
        },
    },
    created: function () {
        var config = this.$root.config || {}
        this.company = config.company || {}
        this.user = config.user || {}
        this.user.headimgurl = this.user.headimgurl || '../images/headimg.png'
        this.user.nickname = this.user.nickname || '无名'

        // 登录系统，更新页面数据
        // this.$on('global:login',this.updata);
        // this.$on('global:quit',this.updata);
    },
})
