Vue.component('maker-editor-texts', {
	template:
	'<div class="editor_texts" @click="$root.setSelect()">'+
		'<div class="editor_tips">双击虚线区域可编辑文字</div>'+
		'<div class="editor_type" ref="editor_type" @touchstart="setTime($event)" @touchend="setType($event)" @click.stop="">'+
			'<ul>'+
				'<li type="toback"><i class="iconfont icon-left"></i><span>返回</span></li>'+
				'<li type="content"><i class="iconfont icon-bianji"></i><span>编辑文字</span></li>'+
				'<li type="color"><i class="iconfont icon-huihuaban"></i><span>文字颜色</span></li>'+
				'<li type="fontsize"><i class="iconfont icon-wenzi"></i><span>更改字体</span></li>'+
				'<li type="position"><i class="iconfont icon-linespacing"></i><span>大小位置</span></li>'+
				'<li type="shadow"><i class="iconfont icon-shadow"></i><span>描边阴影</span></li>'+
				'<li type="remove"><i class="iconfont icon-shanchu"></i><span>删除文字</span></li>'+
			'</ul>'+
		'</div>'+
		'<div class="editor_other editor_content" v-if="type == \'content\'"  @click.stop="">'+
			'<cite @click.stop="type = \'\'"></cite>'+
			'<label class="title"></label>'+
			'<textarea type="text" value="" id="content"></textarea>'+
			'<h6 @click.stop="changeContent()">完成</h6>'+
		'</div>'+
		'<div class="editor_other" v-if="type == \'color\'" @click.stop=""><swatches-picker v-model="color" ></swatches-picker></div>'+
		'<div class="editor_other" v-if="type == \'fontsize\'" @click.stop="" v-loading="familylist.length == 0">'+
			'<ul>'+
				'<li v-for="item in familylist" :key="item.id" '+
					':class="{active:item.id == select.fontFamily}"'+
					'@click="select.fontFamily = item.id;select.fontname=item.name">'+
					'<i class="iconfont icon-checkboxselect"></i>'+
					'<img :src="$cache(item.smallUrl,\'IMAGE\')" />'+
				'</li>'+
			'</ul>'+
		'</div>'+
		'<div class="editor_other" v-if="type == \'position\'" @click.stop="">'+
			'<p>文字大小:（{{(select.fontSize * Math.min(page.width,page.height)).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.fontSize" :min="0" :max="1"></vue-slider>'+
			'<br />'+
			'<p>文字偏左:（{{(select.x * page.width).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.x" :min="-1" :max="1"></vue-slider>'+
			'<br />'+
			'<p>文字偏顶:（{{(select.y * page.height).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.y" :min="-1" :max="1"></vue-slider>'+
			'<br />'+
			'<p>容器宽度:（{{(select.w * page.width).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.w" :min="0" :max="2"></vue-slider>'+
			'<br />'+
			'<p>容器高度:（{{(select.h * page.height).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.h" :min="0" :max="2"></vue-slider>'+
			'<br />'+
			'<p>行高:（{{select.lineHeight.toFixed(4)}}倍）</p>'+
			'<vue-slider v-model="select.lineHeight"  :min="0" :max="10"></vue-slider>'+
			'<br />'+
			'<p>文字间距:（{{select.letterSpacing.toFixed(4)}}倍）</p>'+
			'<vue-slider v-model="select.letterSpacing"  :min="0" :max="1"></vue-slider>'+
		'</div>'+
		'<div class="editor_other" v-if="type == \'shadow\'" @click.stop="">'+
			'<p>描边大小:（{{select.strokeSize.toFixed(4)}}倍）</p>'+
			'<vue-slider v-model="select.strokeSize" :min="0.1" :max="10"></vue-slider>'+
			'<p>阴影偏左:（{{select.shadowX.toFixed(4)}}倍）</p>'+
			'<vue-slider v-model="select.shadowX" :min="0.01" :max="0.5"></vue-slider>'+
			'<p>阴影偏上:（{{select.shadowY.toFixed(4)}}倍）</p>'+
			'<vue-slider v-model="select.shadowY" :min="0.01" :max="0.5"></vue-slider>'+
			'<p>阴影模糊度:（{{select.shadowSize.toFixed(4)}}倍）</p>'+
			'<vue-slider v-model="select.shadowSize" :min="0.1" :max="2"></vue-slider>'+
		'</div>'+
		'<div class="editor_close" v-if="type" @click.stop="type = \'\'"></div>'+
	'</div>',
	props: {
		"select":{type:Object,default:null,required: true},
		'page': {type:Object,default:null,required: true},
	},
	components: {'swatches-picker': VueColor.Swatches},
	data: function() {
		return {
			type:'',
			familylist:[],
			loading:false, // 是否正在更新中
			iscroll:null,
			touchevent:null,
		};
	},
	computed:{

		color:{
			get:function(){return this.select.color;},
			set:function(value){
				var color = (value || {}).hex;
				if(!color){return;}
				if(!/^#([\w\d]{3}|[\w\d]{6})$/.test(color)){return;}
				if(color == this.select.color){return;}

				this.select.color = color;
			}
		},

		// <div class="operating_texts_buttons" ref="operating_texts_buttons">
		// 	<ul>
		// 		<li @click="setType($event)" :class="{active:type=='content'}" type="content"><i class="iconfont icon-bianji"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='font'}" type="font"><span v-text="select.fontname || '默认字体'"></span> <i class="iconfont icon-gundong"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='color'}" type="color"><i :style="{background:select.color}"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='size'}" type="size"><i v-text="getSize()"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='align'}" type="align"><i class="iconfont icon-fontcenter"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='linespacing'}" type="linespacing"><i class="iconfont icon-linespacing"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='writingmode'}" type="writingmode"><i class="iconfont icon-writingmode"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='transparent'}" type="transparent"><i class="iconfont icon-transparent"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='border'}" type="border"><i class="iconfont icon-bumiaobian"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='shadow'}" type="shadow"><i class="iconfont icon-shadow"></i></li>
		// 		<li @click="setType($event)" :class="{active:type=='remove'}" type="remove"><i class="iconfont icon-shanchu"></i></li>
		// 	</ul>
		// </div>
		
		// <!-- 编辑内容 -->
		// <div class="operating_texts_value" type="content" v-if="type == 'content'">
		// 	<textarea v-model="select.value" @input="updata()"></textarea>
		// </div>

		
		// <!-- 颜色 -->
		// <div class="operating_texts_value" type="color" v-if="type == 'color'">
		// 	<swatches-picker v-model="color"></swatches-picker>
		// </div>

		// <!-- 文字大小 -->
		// <div class="operating_texts_value" type="size" v-if="type == 'size'">
		// 	<p>文字大小:<em v-text="getSize()"></em></p>
		// 	<vue-slider :value="parseFloat(select.fontSize)/100" @input="setSize" :min="0" :max="1"></vue-slider>
		// </div>	

		// <!-- 对齐方式 -->
		// <div class="operating_texts_value" type="align" v-if="type == 'align'">
		// 	<p>文字对齐</p>
		// 	<button :class="isCheck('textAlign','left')" @click="updata('textAlign','left')"><i class="iconfont icon-fontleft"></i></button>
		// 	<button :class="isCheck('textAlign','center')" @click="updata('textAlign','center')"><i class="iconfont icon-fontcenter"></i></button>
		// 	<button :class="isCheck('textAlign','right')" @click="updata('textAlign','right')"><i class="iconfont icon-fontright"></i></button>
		// 	<button :class="isCheck('verticalAlign','top')" @click="updata('verticalAlign','top')"><i class="iconfont icon-fonttop"></i></button>
		// 	<button :class="isCheck('verticalAlign','middle')" @click="updata('verticalAlign','middle')"><i class="iconfont icon-fontmiddle"></i></button>
		// 	<button :class="isCheck('verticalAlign','bottom')" @click="updata('verticalAlign','bottom')"><i class="iconfont icon-fontbottom"></i></button>

		// 	<p>行高对齐</p>
		// 	<button :class="isCheck('baseLine','top')" @click="updata('baseLine','top')"><i class="iconfont icon-linetop"></i></button>
		// 	<button :class="isCheck('baseLine','middle')" @click="updata('baseLine','middle')"><i class="iconfont icon-linemiddle"></i></button>
		// 	<button :class="isCheck('baseLine','bottom')" @click="updata('baseLine','bottom')"><i class="iconfont icon-linebottom"></i></button>
		// </div>

		// <!-- 行高字间距 -->
		// <div class="operating_texts_value" type="linespacing" v-if="type == 'linespacing'">
		// 	<p>行高(倍)：{{select.lineHeight}}</p>
		// 	<vue-slider v-model="select.lineHeight" @input="updata()" :min="0" :max="10"></vue-slider>
		// 	<p>文字间距(倍)：{{select.letterSpacing}}</p>
		// 	<vue-slider v-model="select.letterSpacing" @input="updata()" :min="0" :max="1"></vue-slider>
		// </div>

		// <!-- 文字书写方向 -->
		// <div class="operating_texts_value" type="writingmode" v-if="type == 'writingmode'">
		// 	<p>书写方向</p>
		// 	<button :class="isCheck('writingMode','lr-tb')" @click="updata('writingMode','lr-tb')"><i class="iconfont icon-writing-lrtb"></i></button>
		// 	<button :class="isCheck('writingMode','rl-tb')" @click="updata('writingMode','rl-tb')"><i class="iconfont icon-writing-rltb"></i></button>
		// 	<button :class="isCheck('writingMode','lr-bt')" @click="updata('writingMode','lr-bt')"><i class="iconfont icon-writing-lrbt"></i></button>
		// 	<button :class="isCheck('writingMode','rl-bt')" @click="updata('writingMode','rl-bt')"><i class="iconfont icon-writing-rlbt"></i></button>
		// 	<br />
		// 	<button :class="isCheck('writingMode','tb-lr')" @click="updata('writingMode','tb-lr')"><i class="iconfont icon-writing-tblr"></i></button>
		// 	<button :class="isCheck('writingMode','tb-rl')" @click="updata('writingMode','tb-rl')"><i class="iconfont icon-writing-tbrl"></i></button>
		// 	<button :class="isCheck('writingMode','bt-lr')" @click="updata('writingMode','bt-lr')"><i class="iconfont icon-writing-btlr"></i></button>
		// 	<button :class="isCheck('writingMode','bt-rl')" @click="updata('writingMode','bt-rl')"><i class="iconfont icon-writing-btrl"></i></button>
		// </div>

		// <!-- 透明度 -->
		// <div class="operating_texts_value" type="transparent" v-if="type == 'transparent'">
		// 	<p>透明度</p>
		// 	<vue-slider v-model="select.transparent" @input="updata()" :min="0" :max="1"></vue-slider>
		// </div>

		// <div class="operating_texts_value" type="border" v-if="type == 'border'">
		// 	<p>描边大小</p>
		// 	<vue-slider v-model="select.strokeSize" @input="updata()" :min="0.1" :max="10"></vue-slider>
		// 	<swatches-picker v-model="strokeColor"></swatches-picker>
		// </div>

		// <div class="operating_texts_value" type="shadow" v-if="type == 'shadow'">
		// 	<p>阴影偏左(倍)</p>
		// 	<vue-slider v-model="select.shadowX" @input="updata()" :min="0.1" :max="10"></vue-slider>
		// 	<p>阴影偏上(倍)</p>
		// 	<vue-slider v-model="select.shadowY" @input="updata()" :min="0.1" :max="10"></vue-slider>
		// 	<p>阴影模糊度(倍)</p>
		// 	<vue-slider v-model="select.shadowSize" @input="updata()" :min="0.1" :max="10"></vue-slider>
		// 	<swatches-picker v-model="shadowColor"></swatches-picker>
		// </div>

		// strokeColor: {
		// 	get:function(){return this.select.strokeColor;},
		// 	set:function(value){
		// 		var color = (value || {}).hex;

		// 		if(!color){return;}
		// 		if(!/^#([\w\d]{3}|[\w\d]{6})$/.test(color)){return;}
		// 		if(color == this.select.strokeColor){return;}

		// 		this.select.strokeColor = color;
		// 		this.updata();
		// 	}
		// },
		// shadowColor: {
		// 	get:function(){return this.select.shadowColor;},
		// 	set:function(value){
		// 		var color = (value || {}).hex;

		// 		if(!color){return;}
		// 		if(!/^#([\w\d]{3}|[\w\d]{6})$/.test(color)){return;}
		// 		if(color == this.select.shadowColor){return;}

		// 		this.select.shadowColor = color;
		// 		this.updata();
		// 	}
		// },
	},
	methods: {

		// 取字体
		getFontFamily:function(){
			var that = this;
			var family = this.familylist;
			if(family.length <= 0){
				this.$ajax('resource_fontfamily',{},function(json){
					(json.data || []).map(function(item){family.push(item);});
				});
			}
		},

		// 设置状态之前保存点击时间，为解决iscroll 不能响应 click 事件问题，-_-!
		setTime:function(event){
			var touche = event.touches[0];
			this.touchevent = {
				time: new Date().getTime(),
				x: touche.screenX,
				y: touche.screenY,
			}
		},

		// 设置标签
		setType:function(event,type){

			if(!type){
				var li = event.target.closest('li');
				type = li ? li.getAttribute('type') : '';
			}
			if(!type){return;}
			if(!this.touchevent){return;}
			if(new Date().getTime() - this.touchevent.time > 100){return;}


			var that = this;
			var list = this.page.module;
			if(type == 'toback'){
				this.$root.setSelect();
			}else if(type == 'fontsize'){
				this.getFontFamily();
			}else if(type == 'remove'){
				this.$confirm('删除文字将不可恢复，您确定删除吗?',['暂不删除','确定删除'],function(value){
					if(value != '确定删除'){return;}
					list.splice(list.indexOf(that.select),1);
					that.$root.setSelect();
				});
				return;
			}else if(type == 'content'){

				this.type = type;
				this.$nextTick(function(){
					var input = document.getElementById('content');
					var value = that.select.value;
					if(input){
						input.value = value;
						if(window.plus){
							if (!!navigator.userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
								var native = window.plus.webview.currentWebview().nativeInstanceObject();
								native.plusCallMethod({"setKeyboardDisplayRequiresUserAction": false});
							} else {
								var Context = window.plus.android.importClass("android.content.Context");
								var InputMethodManager = window.plus.android.importClass("android.view.inputmethod.InputMethodManager");
								var imm = window.plus.android.runtimeMainActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
								imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
							}
						}
						if(input.setSelectionRange){
							input.setSelectionRange(value.length,value.length);
							input.focus();
						}else if(input.createTextRange){
							var range = input.createTextRange();
							range.move('character', value.length);
							range.select();
						}else{
							input.focus();
						}
					}
				});
			}

			this.type = type;
			this.touchevent = null;
		},

		// 修改文字内容
		changeContent:function(){
			var input = document.getElementById('content');
			if(!input){return;}
			this.select.value = input.value;
			this.$root.setHistory();
			this.type = '';
		},
	},

	mounted:function(){
		this.iscroll = new IScroll(this.$refs.editor_type, {
			scrollX: true,
			scrollY: false,
			mouseWheel: true,
			click: true,
			preventDefault: false,
			preventDefaultException: { tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT|A|LI)$/ },
		});

	},
	created: function() {
		var that = this;
		this.familylist = this.$root.familylist || this.familylist;
		this.$root.familylist = this.familylist;

		this.$on('global:maker_setcontent',function(){
			that.touchevent = {time:new Date().getTime()}
			that.setType(null,'content');
		});
	},
	// 销毁
	beforeDestroy:function(){this.iscroll && this.iscroll.destroy();}

});