Vue.component('maker-editor-video', {
	template:
	'<div class="editor_video" @click="$root.setSelect()">'+
		'<div class="editor_tips">移动或双指缩放视频</div>'+
		'<div class="editor_type">'+
			'<ul>'+
				'<li @click.stop="$root.setSelect()"><i class="iconfont icon-left"></i><span>返回</span></li>'+
				'<li @click.stop="$root.doubleTap()"><i class="iconfont icon-images"></i><span>更换视频</span></li>'+
				'<li @click.stop="type = \'size\'"><i class="iconfont icon-chicun"></i><span>视频位置</span></li>'+
				'<li @click.stop="type = \'transparent\'"><i class="iconfont icon-transparent"></i><span>透明度</span></li>'+
			'</ul>'+
		'</div>'+
		'<div class="editor_other" v-if="type == \'transparent\'" @click.stop="">'+
			'<p>透明度：（{{(select.transparent * 100).toFixed(0)}}%）</p>'+
			'<vue-slider v-model="select.transparent" :min="0" :max="1"></vue-slider>'+
		'</div>'+
		'<div class="editor_other" v-if="type == \'size\'" @click.stop="">'+
			'<p>视频宽度：（{{(select.w * page.width).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.w" :min="0" :max="1"></vue-slider>'+
			'<br />'+
			'<p>视频高度：（{{(select.h * page.height).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.h" :min="0" :max="1"></vue-slider>'+
			'<br />'+
			'<p>距离左边：（{{(select.x * page.width).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.x" :min="0" :max="1"></vue-slider>'+
			'<br />'+
			'<p>距离上边：（{{(select.y * page.height).toFixed(2)}}cm）</p>'+
			'<vue-slider v-model="select.y" :min="0" :max="1"></vue-slider>'+
			'<br />'+
		'</div>'+
		'<div class="editor_close" v-if="type" @click.stop="type = \'\'"></div>'+
	'</div>',
	props: {page:{type:Object,default:{}},select:{type:Object,default:{}}},
	data: function() {
		return {
			type:'',
		};
	},
	methods: {
		// 修改视频
		makerImage:function(selected){


			if(!selected){return;}
			if(!selected[0]){return;}

			var data = this.select;
			var image = selected[0];
			var groups = {};

			// 解析新模板数据，按 pid 进行分组
			this.page.module.map(function(item){
				groups[item.pid] = groups[item.pid] || {};
				groups[item.pid][item.mark] = item;
			});

			var group = groups[data.pid] || {};

			// 修改视频 dishe
			// data.url = image.middleUrl;
			data.type = /video|image/.test(image.type) ? image.type : data.type;
			data.url = image.middleUrl;
			data.gid = image.gId || '';
			data.rid = image.res_id || '';


			// 视频宽度、高度、偏移值
			data.title = image.name;
			data.imageW = parseInt(image.middleWidth);
			data.imageH = parseInt(image.middleHeight);

			data.offsetX = 0;
			data.offsetY = 0;
			data.offsetW = 1;
			data.offsetH = 1;

			if(data.type == 'video'){
				data.poster = image.smallUrl;
			}else{
				delete data.poster;
			}

			group.title && (group.title.value = data.title); // 修改菜品名称
			// group.price && (group.price.value = item.price); // 修改菜品价格

			this.$root.setHistory();
			this.$toast({video:'替换视频完成',image:'替换图片完成'}[data.type]);

		}
	},

	created: function() {
		this.$on('global:maker_editor_picture',this.makerImage);
	},

});