Vue.use(function (Vue, options) {
    // app的域名接口，从api.beta.51zhaocaitu.com/app 变成了 app-api.beta.51zhaocaitu.com哈。

    var develop = false // 是否是开发环境
    if (develop) {
        // 开发环境
        var api = 'http://app-api.beta.51zhaocaitu.com' // 接口地址
        // var api    = "https://yapi.it-lian.com/mock/12"; 		// 接口地址
        var host = 'http://www.beta.51zhaocaitu.com' // 网页地址
        var oss = 'http://data.beta.51zhaocaitu.com' // 图片地址
    } else {
        // 正式环境
        var api = 'https://app-api.51zhaocaitu.com' // 接口地址
        var host = 'https://www.51zhaocaitu.com' // 网页地址
        var oss = 'https://data.51zhaocaitu.com' // 图片地址
    }

    // 接口地址
    Vue.prototype.$api = function (type, opt) {
        var option = opt || {}

        // 静态地址，优先使用表达地址
        var static = {
            SHARE: host + '/share/' + option.seller_id + '/' + option.gId + '.html', //分享地址 http://www.51zhaocaitu.com/share/1/38.html,
            IMAGE: oss, //图片路径
            FONTIMAGE: oss + '/font', // 字体图片服务器路径
            FONTPATH: api + '/font/getSvg.do', // 字体图片服务器路径
        }

        // 路径，命名规范：模块_事件_附加
        var map = {
            // 登陆模块
            login_signin: { url: '/auth/login.do', method: 'post' }, // 登录接口
            login_bind: { url: '/auth/bindPhoneNumber.do', method: 'post' }, // 登录接口
            login_verify: { url: '/verify/message.do', method: 'post' }, //  验证手机接收验证码
            loginout: { url: '/auth/loginOut.do', method: 'post' }, //  退出

            // 首页板块
            main_init: { url: '/index/init.do', method: 'post' }, // 获取首页主题数据
            subject_search: { url: '/subject/list.do', method: 'get' }, // 获取主题列表
            subject_detail: { url: '/subject/details.do', method: 'get' }, // 获取主题列表详情

            // 图库搜索板块
            gallery_search: { url: '/gallery/find.do', method: 'get' }, // 图库搜索
            gallery_detail: { url: '/gallery/details.do', method: 'get' }, // 图片详情
            dish_search: { url: '/dish/find.do', method: 'get' }, // 菜品列表
            dish_detail: { url: '/dish/detail.do', method: 'get' }, // 菜品详情

            // 收藏
            collect_search: { url: '/userCollection/findGallery.do', method: 'get' }, // 收藏列表
            collect_active: { url: '/userCollection/collect.do', method: 'post' }, // 收藏图片
            collect_cancel: { url: '/userCollection/uncollect.do', method: 'post' }, // 取消收藏
            collect_folder: { url: '/userCollection/findFolder.do', method: 'get' }, // 文件夹列表
            collect_folder_save: { url: '/userCollection/saveFolder.do', method: 'post' }, // 保存文件夹
            collect_folder_remove: { url: '/userCollection/deleteFolder.do', method: 'post' }, // 删除文件夹
            collect_moveToFolder: { url: '/userCollection/movePictureToFolder.do', method: 'post' }, // 图片移动到文件夹
            collect_folder_manage: { url: '/userCollection/manageFolders.do', method: 'post' }, // 收藏夹批量操作

            // 灯箱片
            lightbox_size: { url: '/lightbox/find.do', method: 'get' }, //根据尺寸获取灯箱片模板
            lightbox_temp: { url: '/lightbox/details.do', method: 'get' }, //获取模板详情
            lightbox_common: { url: '/lightbox/findCommonSize.do', method: 'get' }, //常用尺寸
            lightbox_save: { url: '/user/saveLightbox.do', method: 'post' }, //保存用户数据
            lightbox_remove: { url: '/user/deleteLightboxs.do', method: 'post' }, // 删除用户灯箱片数据
            lightbox_record: { url: '/user/findLightboxs.do', method: 'get' }, // 用户灯箱片数据列表
            lightbox_detail: { url: '/user/getLightboxDetails.do', method: 'get' }, // 用户灯箱片详情

            // 海报
            poster_list: { url: '/poster/find.do', method: 'get' }, // 海报列表
            poster_temp: { url: '/poster/details.do', method: 'get' }, //获取模板详情
            poster_record: { url: '/user/findPosters.do', method: 'get' }, // 用户海报列表
            poster_save: { url: '/user/savePoster.do', method: 'post' }, //用户海报保存
            poster_remove: { url: '/user/deletePosters.do', method: 'post' }, // 用户海报删除
            poster_common: { url: '/poster/findCommonSize.do', method: 'get' }, //常用尺寸
            poster_detail: { url: '/user/getPosterDetails.do', method: 'get' }, // 用户海报详情

            // 云菜谱
            yunrecipe_Category: { url: '/device/listTemplateCategory.do', method: 'get' }, //云菜谱分类
            yunrecipe_list: { url: '/device/listTemplate.do', method: 'get' }, //云菜谱模版列表
            yunrecipe_detail: { url: '/device/detailTemplate.do', method: 'get' }, //云菜谱模版详情

            // 菜谱
            recipe_list: { url: '/recipe/find.do', method: 'get' }, // 菜谱列表
            recipe_detail: { url: '/recipe/details.do', method: 'get' }, // 菜谱详情
            recipe_generate: { url: '/recipe/autoGenerate.do', method: 'post' }, // 自动生成菜谱
            recipe_template: { url: '/recipe/findTemplates.do', method: 'get' }, // 菜谱模板数据
            recipe_remove: { url: '/userRecipe/delete.do', method: 'post' }, //用户菜谱删除，分为整本和单页
            recipe_record: { url: '/userRecipe/find.do', method: 'get' }, //用户菜谱列表
            recipe_pages: { url: '/userRecipe/details.do', method: 'get' }, //用户菜谱详情
            recipe_save: { url: '/userRecipe/saveTheme.do', method: 'post' }, // 保存菜谱主题
            recipe_page_remove: { url: '/userRecipe/deletePages.do', method: 'post' }, //删除单页菜谱
            recipe_page_sort: { url: '/userRecipe/saveTemplatesPage.do', method: 'post' }, // 批量修改页码
            recipe_page_save: { url: '/userRecipe/saveTemplate.do', method: 'post' }, // 保存单页菜谱

            // 云屏
            yunscreen_list: { url: '/userDevice/list.do', method: 'get' }, //云屏列表
            yunscreen_detail: { url: '/userDevice/detail.do', method: 'get' }, //云屏详情
            yunscreen_bind: { url: '/userDevice/bind.do', method: 'post' }, //云屏解绑
            yunscreen_unbind: { url: '/userDevice/unBind.do', method: 'post' }, //云屏解绑
            yunscreen_rename: { url: '/userDevice/rename.do', method: 'post' }, //云屏重命名
            yunscreen_rotate: { url: '/userDevice/rotate.do', method: 'post' }, //云屏旋转
            yunscreen_sendOrder: { url: '/userDevice/sendOrder.do', method: 'post' }, //云屏发送命令
            yunscreen_setprogram: { url: '/userDevice/bindProgram.do', method: 'post' }, // 云屏添加节目
            yunscreen_setBootTime: { url: '/userDevice/saveBootTime.do', method: 'post' }, // 云屏开关机时间

            yunscreen_program_list: { url: '/userDevice/listProgram.do', method: 'get' }, // 节目列表
            yunscreen_program_save: { url: '/userDevice/saveProgram.do', method: 'post' }, // 保存节目
            yunscreen_program_remove: { url: '/userDevice/deleteProgram.do', method: 'post' }, // 删除节目
            yunscreen_program_detail: { url: '/userDevice/detailProgram.do', method: 'post' }, // 节目详情

            yunscreen_saveProgramPlayTime: { url: '/saveProgramPlayTime.do', method: 'post' }, //保存节目播放时段

            // 地址
            address_list: { url: '/userAddress/find.do', method: 'get' }, //获取所有地址
            address_update: { url: '/userAddress/save.do', method: 'post' }, //保存编辑地址或保存新建地址
            address_remove: { url: '/userAddress/delete.do', method: 'post' }, //删除地址
            address_default: { url: '/userAddress/setDefault.do', method: 'post' }, //设置默认收货地址

            // 设置
            setting_service: { url: '/policy/service.do', method: 'get' }, // 用户隐私政策
            setting_privacy: { url: '/policy/privacy.do', method: 'get' }, //用户服务协议
            feedback_record: { url: '/user/findFeedBacks.do', method: 'get' }, //获取用户意见反馈和版本协议
            feedback_submit: { url: '/user/saveFeedback.do', method: 'post' }, //提交用户意见反馈

            // 上传
            upload_search: { url: '/user/findGallery.do', method: 'get' }, //获取用户上传的图片
            upload_insert: { url: '/user/saveGallery.do', method: 'post' }, // 添加图片
            upload_remove: { url: '/user/deleteGallery.do', method: 'post' }, //删除我的上传图片
            upload_file: { url: '/file/upload.do', method: 'post' }, // 上传图片到服务器
            upload_oss: { url: '/file/getOssConfig.do', method: 'post' }, // 获取oss配置

            // 订单
            order_record: { url: '/userOrder/find.do', method: 'get' }, //获取订单列表
            order_remove: { url: '/userOrder/delete.do', method: 'post' }, //删除订单
            order_receipt: { url: '/userOrder/confirm.do', method: 'post' }, //确认收货
            order_detail: { url: '/userOrder/details.do', method: 'get' }, //获取订单详情
            order_express: { url: '/userOrder/express.do', method: 'get' }, //查看物流接口
            order_build: { url: '/order/place.do', method: 'post' }, //下单统一接口（传不同type值）
            order_pay: { url: '/order/pay.do', method: 'post' }, // 支付订单
            order_amount: { url: '/order/amount.do', method: 'post' }, // 获取订单价格

            resource_fontfamily: { url: '/font/find.do', method: 'get' }, // 获取字体列表
            user_destory: { url: '/user/destroy.do', method: 'post' }, // 获取字体列表

        }

        if (static[type]) {
            return static[type]
        } else if (map[type]) {
            // return api + map[type].url;
            return { url: api + map[type].url, method: map[type].method }
        } else {
            return { url: api + type, method: 'get' } // 直接就是url请求,一般都是get
        }
    }

    // 打开新页面
    Vue.prototype.$toLink = function (link, option, anmi) {
        if (!link) {
            return
        }

        var query = {}
        var querystring = ''
        var parse = this.$urlParse(link)
        var request = option || {} // 参数
        var fullpath = parse.origin + parse.path

        // 把参数都放到opt中
        for (var key in parse.params) {
            !request[key] && (request[key] = parse.params[key])
        }

        // 复杂类型数据保存进localstore
        for (var key in request) {
            var type = Object.prototype.toString.call(request[key])
            if (type == '[object Array]' || type == '[object Object]') {
                // 对象，则先存到localstore中
                var name = 'querystorage-' + key
                var value = request[key]
                request[key] = name
                localStorage.setItem(name, JSON.stringify(value))
            } else {
                // 普通参数不处理
            }

            query[key] = request[key]
        }

        querystring = Object.keys(query)
            .map(function (key) {
                return key + '=' + query[key]
            })
            .join('&')
        querystring = querystring ? '?' + querystring : ''

        if (window.plus) {
            // 兼容immersed状态栏模式
            var topoffset = plus.navigator.isImmersedStatusbar()
                ? Math.round(plus.navigator.getStatusbarHeight()) + 44 + 'px'
                : '44px'
            var id = parse.file
            var style = {
                top: '0px',
                bottom: '0px',
                bounce: 'none',
                background: '#f5f5f5',
            }

            var webview = window.plus.webview.getWebviewById(id)

            if (webview) {
                webview.show(anmi || 'pop-in', 300)
                webview.evalJS(
                    'window.history.replaceState && window.history.replaceState({},"","' +
                        id +
                        querystring +
                        '")'
                )
            } else {
                window.plus.webview.create(id + querystring, id, style).show(anmi || 'pop-in', 300)
            }
        } else {
            window.location.href = parse.origin + parse.path + querystring
        }
    }

    // 统一请求 分 post 和 get 处理
    Vue.prototype.$ajax = function (urltype, opt, callback, upload) {
        var that = this
        var xhr = new XMLHttpRequest()
        var query = []
        var apiInfo = this.$api(urltype) || {}
        var url = apiInfo.url || apiInfo
        var method = (apiInfo.method || 'get').toLocaleLowerCase() || 'get'

        xhr.timeout = 20000 // 超时时间，单位是毫秒
        xhr.withCredentials = true

        if (method == 'get') {
            for (var key in opt) {
                query.push(key + '=' + opt[key])
            }
            url = decodeURI(url).replace(/([^/?&=]+)=([^/?&=]+)/gi, function (a, b, c) {
                opt[b] = c
                return ''
            })
            query.length && (url += url.indexOf('?') < 0 ? '?' + query.join('&') : query.join('&'))
            xhr.open(method, url, true)
        } else {
            xhr.open(method, url, true)
        }

        // 携带token
        // xhr.setRequestHeader('accessToken', localStorage.getItem('token') || "");
        xhr.setRequestHeader('Access-Token', localStorage.getItem('token') || '')
        xhr.setRequestHeader('App-Version', localStorage.getItem('App-Version') || '')
        xhr.setRequestHeader('Device-Type-Id', localStorage.getItem('Device-Type-Id') || '')
        xhr.onload = function (e) {
            if (this.status == 200 || this.status == 304) {
                var json

                try {
                    json = JSON.parse(xhr.responseText)
                } catch (e) {
                    json = {}
                }

                // console.log('---------------------------')
                // console.log('【url】: ' + url)
                // console.log('【req】: ' + JSON.stringify(opt))
                // console.log('【res】: ' + JSON.stringify(json))

                // 如果code == 100 ,表示未登录，需要退出登录
                if (json && json.code == 401) {
                    that.$toast(json.message || '登录已过期，请重新登录')
                    that.$emit('global:quit', null)
                } else {
                    callback && callback.call(that, json)
                }
            } else {
                callback && callback.call(that, { code: 400, msg: '返回错误' })
            }
        }
        xhr.ontimeout = function (e) {
            callback && callback.call(that, { code: 400, msg: '连接超时' })
        }
        xhr.onerror = function (e) {
            callback && callback.call(that, { code: 400, msg: '连接错误' })
        }

        if (method == 'get') {
            xhr.send()
        } else {
            xhr.send(JSON.stringify(opt))
        }
    }

    // ajax调用
    Vue.prototype.$post = function (urltype, opt, callback, upload) {
        var that = this
        var form = new FormData()
        var xhr = new XMLHttpRequest()

        for (var key in opt) {
            var type = Object.prototype.toString.call(opt[key])
            if (type == '[object Array]') {
                form.append(key, JSON.stringify(opt[key]))
            } else if (type == '[object Object]') {
                form.append(key, JSON.stringify(opt[key]))
            } else {
                form.append(key, opt[key])
            }
        }

        // form.append('token',localStorage.getItem('token') || "");
        form.append('source', 'APP')

        xhr.timeout = upload ? 108000000 : 20000 // 超时时间，单位是毫秒
        xhr.open('post', this.$api(urltype).url, true)
        // xhr.setRequestHeader('accessToken', localStorage.getItem('token') || "");
        xhr.setRequestHeader('Access-Token', localStorage.getItem('token') || '')
        xhr.setRequestHeader('App-Version', localStorage.getItem('App-Version') || '')
        xhr.setRequestHeader('Device-Type-Id', localStorage.getItem('Device-Type-Id') || '')
        xhr.onload = function (e) {
            if (this.status == 200) {
                var json
                try {
                    json = JSON.parse(xhr.responseText)
                } catch (e) {
                    json = {}
                }

                // 如果error_code == 100 ,表示未登录，需要退出登录
                if (json && json.error_code == 100) {
                    that.$toast(json.msg)
                    // that.$emit('global:quit',null);
                } else {
                    // console.log(JSON.stringify(json));

                    // console.log('---------------------------')
                    // console.log('【url】: '+ that.$api(urltype) + '; 【token】:'+ (localStorage.getItem('token') || ''));
                    // console.log('【req】: '+ JSON.stringify(opt));
                    // console.log('【res】: '+ JSON.stringify(json));

                    callback && callback(json)
                }
            } else {
                callback && callback({ error_code: 4, msg: '返回错误' })
            }
        }
        xhr.ontimeout = function (e) {
            callback && callback('timeout')
        }
        xhr.onerror = function (e) {
            callback && callback('error')
        }
        // 获取上传进度
        xhr.upload.onprogress = upload

        xhr.send(form)
    }

    // 图片上传
    // Vue.prototype.$upload = function(option,callback) {

    // 	var that = this;
    // 	var form = new FormData();
    // 	var xhr = new XMLHttpRequest();
    // 	var filetype = ((option.file || {}).type || '').replace(/^[\w\W]*\//,'');
    // 	var filename = (option.file || {}).name || ('unnamed.' + filetype);

    // 	form.append('type',option.type);
    // 	form.append('file',option.file, filename);
    // 	form.append('width',option.width);
    // 	form.append('height',option.height);
    // 	form.append('source','APP');

    // 	xhr.timeout = 108000000; // 超时时间，单位是毫秒
    // 	xhr.open('post',  this.$api('upload_file').url,true);
    // 	xhr.setRequestHeader('Access-Token', localStorage.getItem('token') || "");
    // 	xhr.onload = function(e) {
    // 	    if(this.status == 200){
    // 	    	var json;
    // 			try{json = JSON.parse(xhr.responseText);}catch(e){json = {}}
    // 			callback && callback.call(that,json);
    // 		} else {
    // 			callback && callback.call(that,{code:400,msg:'返回错误'});
    // 		}
    // 	};
    // 	xhr.ontimeout = function(e) {callback && callback.call(that,{code:400,msg:'请求超时'});};
    // 	xhr.onerror = function(e) { callback && callback.call(that,{code:400,msg:'请求错误'});};
    // 	// 获取上传进度
    // 	xhr.upload.onprogress = function(event){
    // 		if (event.lengthComputable) {
    // 			var percent = Math.floor(event.loaded / event.total * 100);
    // 			callback && callback.call(that,{code:100,percent:percent,msg:'正在上传'});
    // 		}
    // 	}
    // 	xhr.send(form);
    // }

    // 获取oss客户端
    Vue.prototype.$getOssClient = function (callback) {
        var that = this
        var xhr = new XMLHttpRequest()
        xhr.timeout = 108000000 // 超时时间，单位是毫秒
        xhr.open('post', this.$api('upload_file').url, true)
        xhr.setRequestHeader('Access-Token', localStorage.getItem('token') || '')
        xhr.setRequestHeader('App-Version', localStorage.getItem('App-Version') || '')
        xhr.onload = function (e) {
            if (this.status == 200) {
                var json
                try {
                    json = JSON.parse(xhr.responseText)
                } catch (e) {
                    json = {}
                }
                callback && callback.call(that, json)
            } else {
                callback && callback.call(that, { code: 400, msg: '返回错误' })
            }
        }
        if (!window.OSSCACHE) {
            window.OSSCACHE = {
                loading: false,
                client: null,
                config: {},
                loop: [],
            }
        }

        if (!window.OSSCACHE.client) {
            // 没有oss，要先加载oss
            if (!window.OSSCACHE.loading) {
                // 未加载
                var checkOss = function () {
                    if (window.OSS) {
                        // 有结果了
                        // window.OSSCACHE.loading = false;

                        Vue.prototype.$ajax('upload_oss', { type: 'image' }, function (response) {
                            var json = response || {}
                            var data = json.data || {}

                            if (json.code == 200) {
                                window.OSSCACHE.loading = false
                                window.OSSCACHE.config = data
                                window.OSSCACHE.client = new OSS.Wrapper({
                                    accessKeyId: data.accessKeyId,
                                    accessKeySecret: data.accessKeySecret,
                                    stsToken: data.stsToken,
                                    region: data.region,
                                    bucket: data.bucket, // 填写Bucket名称。
                                    secure: true,

                                    // region: 'oss-cn-shenzhen',
                                    // endpoint: 'http://cn-shenzhen.aliyuncs.com'
                                })

                                window.OSSCACHE.loop.map(function (callback) {
                                    callback &&
                                        callback.call(
                                            that,
                                            window.OSSCACHE.client,
                                            window.OSSCACHE.config
                                        )
                                })
                            } else {
                                window.OSSCACHE.loop.map(function (callback) {
                                    callback && callback.call(that)
                                })
                            }
                        })
                    } else {
                        // 未加载完成
                        setTimeout(checkOss, 300)
                    }
                }

                if (!window.OSS) {
                    var script = document.createElement('script')
                    script.src = '../scripts/aliyun-oss-sdk.min.js'
                    document.body.appendChild(script)
                }

                window.OSSCACHE.loop.push(callback)
                window.OSSCACHE.loading = true

                checkOss()
            } else {
                // 已加载
                // 加入到队列中
                window.OSSCACHE.loop.push(callback)
            }
        } else {
            callback && callback.call(that, window.OSSCACHE.client, window.OSSCACHE.config)
        }
    }

    // 上传
    Vue.prototype.$upload = function (option, callback) {
        var that = this

        Vue.prototype.$getOssClient(function (client, config) {
            if (!client) {
                callback && callback.call(that, { code: 400, msg: '请求错误' })
            } else {
                var time = new Date().getTime()
                var filetype = ((option.file || {}).type || '').replace(/^[\w\W]*\//, '')
                var random = ('' + Math.random()).substr(-3)
                var userid =
                    JSON.parse(localStorage.getItem('user') || '{}').userId || config.filename
                var filename = userid + '-' + time + '-' + random + '.' + filetype
                var pathtime = Vue.prototype.$dateFormat(time, 'YYMM')
                var fullpath = ['user/gallery', pathtime, filename].join('/')

                // 第二种方式，分片上传
                client
                    .multipartUpload(fullpath, option.file, {
                        parallel: 2,
                        progress: function* (percent, cpt) {
                            callback &&
                                callback.call(that, {
                                    code: 100,
                                    percent: Math.floor(percent * 100),
                                    msg: '正在上传',
                                })
                        },
                    })
                    .then(function (result) {
                        // 成功
                        var data = {
                            originUrl: '/' + fullpath,
                            originWidth: option.width,
                            originHeight: option.height,
                            middleUrl:
                                '/' + fullpath + '?x-oss-process=image/resize,w_800/format,webp',
                            middleWidth: 800,
                            middleHeight: (800 * option.height) / option.width,
                            smallUrl:
                                '/' + fullpath + '?x-oss-process=image/resize,w_500/format,webp',
                            smallWidth: 500,
                            smallHeight: (500 * option.height) / option.width,
                        }

                        if (option.type == 'video') {
                            data.middleUrl = '/' + fullpath
                            data.smallUrl = '/' + fullpath
                        }

                        callback && callback.call(that, { code: 200, msg: '上传成功', data: data })
                    })
                    .catch(function (err) {
                        // 失败
                        callback && callback.call(that, { code: 400, msg: '上传失败' })
                    })
            }
        })
    }

    // 快速获取图片Blob的url
    Vue.prototype.$uploadCanvas = function (canvas, callback) {
        var that = this
        var fileReader = null
        var client = null
        var config = {}

        // 获取上传配置，同时canvas转buffer
        var ready = function () {
            if (fileReader && client) {
                var buffer = new window.OSS.Buffer(fileReader)
                var time = new Date().getTime()
                var random = ('' + Math.random()).substr(-3)
                var userid =
                    JSON.parse(localStorage.getItem('user') || '{}').userId || config.filename
                var filename = userid + '-' + time + '-' + random + '.png'
                var pathtime = Vue.prototype.$dateFormat(time, 'YYMM')
                var fullpath = ['user/thumb', pathtime, filename].join('/')
                buffer.name = filename
                client
                    .put(fullpath, buffer)
                    .then(function (result) {
                        // 成功
                        callback && callback.call(that, '/' + fullpath)
                    })
                    .catch(function (err) {
                        // 失败
                        console.log(err)
                        callback && callback.call(that, '')
                    })
            }
        }

        canvas.toBlob(
            function (blob) {
                var reader = new FileReader()
                reader.readAsArrayBuffer(blob)
                reader.onload = function (event) {
                    fileReader = event.target.result
                    ready()
                }
                reader.onerror = function (event) {
                    callback && callback.call(that, '')
                }
            },
            'image/png',
            1
        )

        Vue.prototype.$getOssClient(function (cli, cfg) {
            if (cli) {
                client = cli
                config = cfg
                ready()
            } else {
                callback && callback.call(that, '')
            }
        })
    }

    // 图片缓存
    Vue.prototype.$cache = function (url, type) {
        var name = type || 'IMAGE'
        var host = this.$api(name)
        return url ? host + url : ''
    }

    //图片自动缩放，超出截断
    Vue.prototype.$autoImage = function (width, height, scale) {
        var s = scale || 1 // 宽高比例，高/宽
        var w = parseInt(width) || 1
        var h = parseInt(height) || 1
        if (h / w > s) {
            return { width: '100%', top: (1 - h / w / s) * 50 + '%' }
        } else {
            return { height: '100%', left: (1 - (s * w) / h) * 50 + '%' }
        }
    }

    // 在容器内显示最大，最大边填满容器
    Vue.prototype.$fiexImage = function (width, height, scale) {
        var s = scale || 1 // 宽高比例，高/宽
        var w = parseInt(width) || 1
        var h = parseInt(height) || 1
        if (h / w > s) {
            return {
                width: ((s * w) / h) * 100 + '%',
                height: '100%',
                left: (1 - (s * w) / h) * 50 + '%',
            }
        } else {
            return {
                width: '100%',
                height: (h / w / s) * 100 + '%',
                top: (1 - h / w / s) * 50 + '%',
            }
        }
    }

    // url 参数解析
    Vue.prototype.$urlParse = function (url) {
        var a = document.createElement('a')
        a.href = url
        return {
            source: url,
            protocol: a.protocol.replace(':', ''),
            host: a.hostname,
            port: a.port,
            query: a.search,
            origin: a.origin,
            params: (function () {
                var ret = {},
                    seg = a.search.replace(/^\?/, '').split('&'),
                    len = seg.length,
                    i = 0,
                    s //len = 2
                for (; i < len; i++) {
                    if (!seg[i]) {
                        continue
                    }
                    s = seg[i].split('=')
                    ret[s[0]] = s[1]
                }
                return ret
            })(),
            file: (a.pathname.match(/\/([^\/?#]+)$/i) || [, ''])[1],
            hash: a.hash.replace('#', ''),
            path: a.pathname.replace(/^([^\/])/, '/$1'),
            relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [, ''])[1],
            segments: a.pathname.replace(/^\//, '').split('/'),
        }
    }

    //获取url中的参数
    Vue.prototype.$urlParam = function (name, url) {
        var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)') //构造一个含有目标参数的正则表达式对象
        var r = (url || window.location.search).substr(1).match(reg) //匹配目标参数
        var res = r != null ? decodeURI(r[2]) : null

        if (/^querystorage\-/.test(res)) {
            // 从localstore中取值
            var storage = localStorage.getItem(res)
            var value = ''
            try {
                value = JSON.parse(storage)
            } catch (e) {
                value = ''
            }

            return value
        } else {
            return res
        }
    }

    // 弹出键盘
    Vue.prototype.$setKeyboard = function (event) {
        var input = event.target
        var value = input.value
        if (input) {
            input.value = value
            if (window.plus) {
                if (!!navigator.userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
                    var native = window.plus.webview.currentWebview().nativeInstanceObject()
                    native.plusCallMethod({ setKeyboardDisplayRequiresUserAction: false })
                } else {
                    var Context = window.plus.android.importClass('android.content.Context')
                    var InputMethodManager = window.plus.android.importClass(
                        'android.view.inputmethod.InputMethodManager'
                    )
                    var imm = window.plus.android
                        .runtimeMainActivity()
                        .getSystemService(Context.INPUT_METHOD_SERVICE)
                    imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED)
                }
            }
            if (input.setSelectionRange) {
                input.setSelectionRange(value.length, value.length)
                input.focus()
            } else if (input.createTextRange) {
                var range = input.createTextRange()
                range.move('character', value.length)
                range.select()
            } else {
                input.focus()
            }
        }
    }

    // 自动消失消息框
    Vue.prototype.$toast = function (tips) {
        var toast = document.querySelector('.toast')

        // 如果toast还在，则不再执行
        if (toast) {
            clearTimeout(toast.timer_miss)
            clearTimeout(toast.timer_remove)

            toast.querySelector('p').innerHTML = tips
            toast.timer_miss = setTimeout(function () {
                toast.style.opacity = '0'
            }, 2500)
            toast.timer_remove = setTimeout(function () {
                document.body.removeChild(toast)
            }, 3000)
        } else {
            // 创建实例，挂载到文档以后的地方
            var toast = document.createElement('div')

            toast.setAttribute('class', 'toast')
            toast.innerHTML = '<p>' + tips + '</p>'
            toast.timer_miss = setTimeout(function () {
                toast.style.opacity = '0'
            }, 2500)
            toast.timer_remove = setTimeout(function () {
                document.body.removeChild(toast)
            }, 3000)
            document.body.appendChild(toast)
        }
    }

    // 确认对话框
    Vue.prototype.$confirm = function () {
        var that = this
        var warp = document.createElement('div')
        var option = Array.prototype.slice.call(arguments)
        var texts = option.filter(function (i) {
            return Object.prototype.toString.call(i) == '[object String]'
        })
        var callback = option.filter(function (i) {
            return Object.prototype.toString.call(i) == '[object Function]'
        })
        var arrays = option.filter(function (i) {
            return Object.prototype.toString.call(i) == '[object Array]'
        })
        var config = option.filter(function (i) {
            return Object.prototype.toString.call(i) == '[object Object]'
        })[0]
        var buttons = Array.prototype.concat.apply([], arrays)

        config = config || {}
        buttons.length == 0 && (buttons = ['确认', '取消'])

        warp.setAttribute('class', 'confirm')
        warp.innerHTML = '<cite><form></form><h6></h6></cite>'
        warp.querySelector('form').innerHTML = texts.join('')
        warp.querySelector('form').onSubmit = function (event) {
            event.stopPropagation()
            event.preventDefault()
        }
        warp.querySelector('h6').innerHTML = buttons
            .map(function (i) {
                return '<button>' + i + '</button>'
            })
            .join('')

        warp.addEventListener(
            'click',
            function (e) {
                var target = e.target
                var name = target.tagName.toLocaleLowerCase()
                if (name == 'button') {
                    if (callback.length > 0) {
                        // 当回调函数retrun true之后，阻止关闭弹窗
                        var stop =
                            callback.filter(function (cb) {
                                return cb.call(that, target.innerHTML, warp)
                            }).length > 0
                        !stop && document.body.removeChild(warp)
                    } else {
                        document.body.removeChild(warp)
                    }
                }

                // else if(name == 'div'){
                // 	!config.force && document.body.removeChild(div);
                // }
            },
            false
        )
        document.body.appendChild(warp)
    }

    // 关闭页面返回
    Vue.prototype.$toBack = function (option) {
        if (window.plus) {
            // 返回
            var home = plus.webview.getLaunchWebview() // 根页面
            var curr = plus.webview.currentWebview() // 当前页面

            if (curr == home) {
                // 返回的是首页
            } else {
                curr.close('pop-out', 300)
            }
        } else {
            window.history.back()
        }
    }

    // 插件，正在加载
    Vue.directive('loading', {
        bind: function (el, binding, vnode) {
            var div = document.createElement('div')
            var val =
                Object.prototype.toString.call(binding.value) === '[object String]'
                    ? binding.value
                    : '正在加载...'
            div.setAttribute('class', 'loading')
            div.setAttribute('style', binding.value ? 'display:block' : 'display:none')
            div.innerHTML =
                '<cite><svg viewBox="25 25 50 50" ><circle cx="50" cy="50" r="20" fill="none" ></circle></svg><p>' +
                val +
                '</p></cite>'

            el.appendChild(div)
            el.loading = div
            el.text = div.querySelector('p')
        },
        update: function (el, binding, vnode) {
            if (binding.value == binding.oldValue) {
                return
            }
            el.loading.setAttribute('style', binding.value ? 'display:block' : 'display:none')
            el.text.innerText =
                Object.prototype.toString.call(binding.value) === '[object String]'
                    ? binding.value
                    : '正在加载...'
        },
    })

    // 时间格式化
    Vue.prototype.$dateFormat = function (time, format) {
        var time = new Date(parseInt(10000000000000 * ('0.' + time)))
        var tpl = format || 'YY-MM-DD hh:mm:ss'
        tpl = tpl.replace('YY', time.getFullYear())
        tpl = tpl.replace('MM', ('00' + (time.getMonth() + 1)).substr(-2, 2))
        tpl = tpl.replace('DD', ('00' + time.getDate()).substr(-2, 2))
        tpl = tpl.replace('hh', ('00' + time.getHours()).substr(-2, 2))
        tpl = tpl.replace('mm', ('00' + time.getMinutes()).substr(-2, 2))
        tpl = tpl.replace('ss', ('00' + time.getSeconds()).substr(-2, 2))
        return tpl
    }

    // 时间格式化
    Vue.filter('format', function (value) {
        return Vue.prototype.$dateFormat(value)
    })
})

// 按钮
Vue.component('zct-button', {
    template:
        '<button @click="$emit(\'click\')" class="zct-button" :type="type"> <slot></slot> </button>',
    data: function () {
        return {}
    },
    props: {
        type: {
            type: String,
            default: function () {
                return 'button'
            },
        },
    },
})

// 空数据
Vue.component('nodata', {
    template:
        '<div class="nodata">' +
        '<i class="iconfont icon-wushuju"></i>' +
        '<p>空空如也...</p>' +
        '</div>',
    data: function () {
        return {}
    },
    methods: {},
    created: function () {},
})
