Vue.component('vue-preview', {
	template: 
	'<div class="vue-preview">'+
		'<div class="title"><cite><a class="title_toback" @click="$emit(\'close\')"><i class="iconfont icon-fanhui"></i></a><div class="swiper-pagination"></div></cite></div>'+
		'<div class="vue-preview-button" v-if="active && !isselect">'+
			'<span @click="collectPicture(active)" :class="{collected:active.collected}"><i class="iconfont icon-shoucang"></i><em v-text="active.collected ? \'已收藏\' : \'收藏\'"></em></span>'+
			'<span @click="sharePicture(active)"><i class="iconfont icon-fenxiang"></i><em>分享</em></span>'+
		'</div>'+
		'<div class="vue-preview-warper" ref="warper">'+
			'<div class="vue-preview-scroller">'+
				'<div class="swiper-container" ref="container" v-loading="loading">'+
					'<div class="swiper-wrapper"></div>'+
					'<div class="swiper-button-prev"><i class="iconfont icon-xiangzuo"></i></div>'+
					'<div class="swiper-button-next"><i class="iconfont icon-xiangyou"></i></div>'+
					
					'<div class="vue-preview-discript" v-if="active">'+
						'<h2><span v-show="active.name" v-text="active.name"></span><span v-show="active.price" v-text="\' (￥\'+active.price+\')\'"></span></h2>'+
						'<p v-text="\'图片销量：\' + (active.useTimes || \'0\')"></p>'+
						'<p v-text="\'收藏数量：\' + (active.collectTimes || \'0\')"></p>'+
						'<p v-show="active.uploaderName" v-text="\'图片所有：\' + (active.uploaderName || \'\')"></p>'+
						'<p v-show="active.material" v-text="\'标签分类：\' + (active.material || \'\')"></p>'+
					'</div>'+
				'</div>'+
				'<div class="vue-preview-detail" v-show.sync="active.detail">'+
					'<div class="vue-preview-item" v-show="active.chefName"><strong>烹饪作者:</strong><span v-text="active.chefName"></span></div>'+
					'<div class="vue-preview-item" v-show="active.photographer"><strong>拍摄作者:</strong><span v-text="active.photographer"></span></div>'+
					'<div class="vue-preview-item" v-show="active.sauce"><strong>调味调料:</strong><span v-text="active.sauce"></span></div>'+
					'<div class="vue-preview-item" v-show="active.drysauce"><strong>干调味料:</strong><span v-text="active.drysauce"></span></div>'+
					'<div class="vue-preview-item" v-show="active.sideDish"><strong>配菜配料:</strong><span v-text="active.sideDish"></span></div>'+
					'<div class="vue-preview-item" v-show="active.tableware"><strong>厨具餐具:</strong><span v-text="active.tableware"></span></div>'+
					'<div class="vue-preview-item" v-show="active.taste"><strong>味道特点:</strong><span v-text="active.taste"></span></div>'+
					'<div class="vue-preview-item" v-show="active.content" ref="content"><strong>制作流程:</strong><div v-html="active.content"></div></div>'+
				'</div>'+
			'</div>'+
		'</div>'+
	'</div>',
	props: {
		option: {
			list: [], // 列表
			item: null, // 当前
			more: null, // 加载更多
			isselect: false, // 是否可选中
		}
	},
	data:function() {
		return {
			loading: false, // 正在加载
			swiper: false, // 滚动条插件
			list: [], // 列表
			more: null, // 加载更多
			active: null, // 当前
			isselect: false, // 是否可选中
			hadcollect:{}, // 改变记录
			cache:{},
		}
	},
	watch: {
		'option.list':function(newArr, oldArr) {

			// 把原来的删除掉
			// 添加新的
			if(!this.swiper){return;}

			var swiper = this.swiper;
			var active = this.list[(this.swiper.activeIndex)];

			this.swiper.removeAllSlides();
			this.swiper.virtual.slides.length = 0;
			this.list = (this.option.list || []).slice(0);
			this.list.map(function(item){swiper.virtual.appendSlide(item);});
			this.swiper.slideTo(this.list.indexOf(active),0);
		}
	},

	methods: {
		// 收藏
		collectPicture:function(item){

			var that = this;
			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var login = (config.user || {}).login;
			var urltype = item.collected ? 'collect_cancel' : 'collect_active';

			if(this.isselect){return;}

			// 如果未登录，则先提示登录
			if(login){
				this.loading = true;
				this.$ajax(urltype,{gIds:item.gId},function(response){

					var json = response || {};

					if(json.code == 200){
						that.$set(item,'collected',urltype == 'collect_active');
						that.$toast(json.message || urltype == 'collect_active' ? '收藏成功':'取消收藏成功');
						that.loading = false;

						if(that.hadcollect[item.gId]){
							that.hadcollect[item.gId].to = item.collected;
						}else{
							that.hadcollect[item.gId] = {
								gId: item.gId,
								form: !item.collected,
								to: item.collected
							}
						}
					}else{
						that.loading = false;
						that.$toast(json.message || urltype == 'collect_active' ? '收藏失败':'取消收藏失败');
					}
							
				});
			}else{
				this.$toLink('index_login.html');
			}

		},

		// 获取图片详情
		getDetail:function(gallery){

			var that = this;
			var gid = gallery.gId;

			if(!gallery){return;}

			if(this.cache[gid]){

				var active = false;
				var keys = ['useTimes','collectTimes','chefName','photographer','sauce','drysauce','sideDish','tableware','taste','content','detail'];
				keys.map(function(key){
					that.$set(gallery,key,that.cache[gid][key] || '');
					active = active || !!that.cache[gid][key];
				});
				
				this.$set(gallery,'detail',active);
				this.$nextTick(function(){
					this.setIscroll();
					this.$refs.content && Array.prototype.slice.apply(this.$refs.content.querySelectorAll('img')).map(function(img){img.onload = that.setIscroll;});
				});
			}else{
				this.$ajax('gallery_detail',{gId:gid},function(response){
					var json = response || {};
					var data = json.data || {};
					if(json.code == 200){
						that.cache[gid] = data
						that.getDetail(gallery);
					}
				});
			}
		},

		setIscroll:function(){
			// 全局滚动
			if(this.iscroll){
				this.iscroll.refresh();
			}else{
				this.iscroll = new IScroll(this.$refs.warper, {
					scrollbars: false,
					interactiveScrollbars: true,
					bounce:true,
					click:true,
					mouseWheel: true,
					mouseWheelSpeed: 1,
				});	
			}
		},

		// 分享图片
		sharePicture:function(item){
			if(!item){return;}
			if(this.isselect){return;}
			this.$root.share = item;
		},
		loadMore:function(){
			if(Object.prototype.toString.call(this.more) === '[object Function]'){this.more();}
		}
	},

	mounted: function() {
		var that = this;
		this.$refs.container.style.height = (this.$refs.warper.offsetHeight - 40) + 'px';
		this.swiper = new Swiper('.swiper-container', {
			loop: false, // 循环模式选项
			pagination: {el: '.swiper-pagination',type:'fraction'},
			navigation: {nextEl: '.swiper-button-next',prevEl: '.swiper-button-prev',}, // 前进后退按钮
			initialSlide: this.list.indexOf(this.active), // 默认选中
			zoom: {containerClass : 'swiper-zoom',maxRatio:10,}, // 缩放
			virtual:{
				slides: this.list, // 虚拟节点
				renderSlide: function(item, index) {
					var tpl = '<div class="swiper-slide"><div class="swiper-zoom"><img src="{url}"></div></div>';
					return tpl.replace('{url}',that.$cache(item.middleUrl || item.smallUrl));
				},
			},
			// 事件
			on:{
				slideChange:function(){
					// 最后一个
					this.activeIndex >= this.virtual.slides.length - 1 && that.loadMore();
					that.active = this.virtual.slides[this.activeIndex];
					that.getDetail(that.active);
				}
			}
		});
		this.getDetail(this.active);
		// that.swiper.virtual.appendSlide(item);
	},
	created: function() {
		var option = this.option || {};
		this.list = (option.list || []).slice(0);
		this.more = option.more === undefined ? this.more : option.more;
		this.active = option.item || this.list[0];
		this.isselect = option.isselect === undefined ? this.isselect : option.isselect; // 是否可选中

	},
	beforeDestroy:function(){

		var collect = [];
		var cancel = [];

		this.swiper = this.swiper && this.swiper.destroy() && null;
		Object.values(this.hadcollect).map(function(item){
			if(item.form != item.to){return;}
			item.to && collect.push(item.gId);
			!item.to && cancel.push(item.gId);
		});

		collect.length > 0 && this.$emit('global:collect',{gId: collect.join(','), action: 'collect', form: 'preview'});
		cancel.length > 0 && this.$emit('global:collect',{gId: cancel.join(','), action: 'cancel', form: 'preview'});
		
	},

});

