Vue.component('vue-share-image', {
	template: 
	'<div class="vue-share" @click="close">'+
		'<cite @click.stop="">'+
			'<p>分享图片到</p>'+
			'<h2><img :style="$autoImage(option.smallWidth,option.smallHeight,0.7)" :src="$api(\'IMAGE\') + option.smallUrl"></h2>'+
			'<ul>'+
				'<li @click="doShare(\'weixin\',\'WXSceneSession\')"><i class="iconfont icon-weixin"></i><span>微信好友</span></li>'+
				'<li @click="doShare(\'weixin\',\'WXSceneTimeline\')"><i class="iconfont icon-pengyouquan"></i><span>朋友圈</span></li>'+
				'<li @click="doShare(\'qq\')"><i class="iconfont icon-qq"></i><span>QQ</span></li>'+
				'<li @click="doShare(\'sinaweibo\')"><i class="iconfont icon-weibo"></i><span>微博</span></li>'+
			'</ul>'+
			'<h5><i @click="close" class="iconfont icon-guanbi"></i></h5>'+
		'</cite>'+
	'</div>',
	props: {
		option: {type: Object,default: {gId: '',smallUrl: '',smallWidth: 0,smallHeight: 0,}},
	},

	data: function() {
		return {
			services:{}
		}
	},
	methods:{
		// 关闭
		close:function(){this.$emit('close');},

		// 分享
		doShare:function(type,scene){

			var that = this;
			var service = this.services[type];
			var config = JSON.parse(localStorage.getItem('config') || '{}');
			var seller_id = (config.company || {}).seller_id || '';
			var gId = this.option.gId;
			var url = this.option.smallUrl;
			
			if(!service){
				this.$toast('无效的分享服务！');
			}else{
				var message = {
					type : 'image',
					title : "全网精品高清菜图-总有你想要的",
					href: this.$api('SHARE', {seller_id: seller_id, gId: gId }),
					content : name + ",全网最全高清菜图,海量优质模版,在线选图,快速制作灯箱片,菜谱一键生成,就上找菜图APP",
					// thumbs : [this.$api('IMAGE') + url],
					pictures:[this.$api('IMAGE') + url],
				}

				if(type == 'weixin'){
					message.extra = {scene:scene};
				}

				// 认证授权
				if(service.authenticated){
					that.shareMessage(message, service);
				}else{
					service.authorize(function(){
						that.shareMessage(message, service);
					}, function(e){
						that.$toast('认证授权失败');
					});
				}
			}

		},

		// 分享信息
		shareMessage:function(msg,service){

			var that = this;
			service.send(msg, function(){
				that.$toast('分享到"'+service.description+'"成功！');
				that.close();
			}, function(e){
				that.$toast('分享到"'+service.description+'"失败:');
			});
		}

	},
	created:function(){

		var that = this;
		if(window.plus){
			 window.plus.share.getServices(function(services){
				for(var key in services){
					var service = services[key];
					that.services[service.id] = service;
				}
			}, function(e){
				that.$toast('获取分享服务列表失败');
			});
		}

	}
});