Vue.component('vue-slider', {
	template:
	'<div class="vue-slider" ref="slider">'+
		'<div class="vue-slider-inner" :style="{width: 100 * percent + \'%\'}"><span @touchstart="touchStart"></span></div>'+
	'</div>',
	props:{
		"value":{type:Number,default:0,required: true},
		"max":{type:Number,default:100},
		"min":{type:Number,default:0}},
	data:function(){
		return{
			percent:0,
			slider:null,
		}
	},
	watch:{
		value:function(New,old){this.init()},
		min:function(New,old){this.init()},
		max:function(New,old){this.init()},
	},
	methods:{
		init:function () {
			this.percent = Math.min(1,Math.max(0,(this.value - this.min) / (this.max - this.min)));
		},
		touchStart:function(e){
			this.slider = {
				width : this.$refs.slider.offsetWidth - 20,
				percent : this.percent,
				screenX : e.touches[0].screenX,
			}
			e.stopPropagation();
			e.preventDefault();
		},
		touchMove:function(e){
			if(!this.slider){return;}
			var percent = this.slider.percent + (e.touches[0].screenX - this.slider.screenX) / this.slider.width;
			this.percent = Math.min(1,Math.max(0,percent));
			this.value = this.percent * (this.max - this.min) + this.min;
			this.$emit('input',this.value);
			e.stopPropagation();
			e.preventDefault();
		},
		touchEnd:function(e){
			if(!this.slider){return;}
			this.slider = null;
			e.stopPropagation();
			e.preventDefault();
			this.$emit('change',this.value);
		},
	},
	created:function(){
		this.init();
		window.addEventListener('touchmove',this.touchMove, false);
		window.addEventListener('touchend',this.touchEnd, false);
	},
	beforeDestroy:function(){
		window.removeEventListener('touchmove',this.touchMove);
		window.removeEventListener('touchend',this.touchEnd);
	}

});