Vue.component('yunscreen-temp', {
    template:
        '<div class="yc_main">' +
        '<div class="yc_main_sidebar">' +
        '<ul><li @click="categorySelect(item,index)" :class="{active:item.id == form.category_id}" v-for="(item,index) in categoryList" :key="index" v-text="item.name"></li></ul>' +
        '</div>' +
        '<div class="yc_main_content" v-loading="loading">' +
        '<vue-scroller ref="scroller" v-if="list.length > 0" :items="list || []" :infinite="true" :pulldown="true" :margin="16" :spacing="10" :column="2" @onloadmore="pagesUpdata(false)" @onpullrefresh="pagesUpdata(true)">' +
        '<template slot="append"><div style="height: 20px"></div></template>' +
        '<template slot="content" slot-scope="props">' +
        '<div class="yc_main_content_item" @click="selectTemp(props.item)">' +
        '<h3 :style="{paddingBottom:props.item.paddingBottom}"><span><img :src="$cache(props.item.thumb,\'IMAGE\')" /></span></h3>' +
        '<div class="yc_main_content_item_dis">' +
        '<h4>{{props.item.title}}</h4>' +
        '<h5>' +
        '<span v-if="parseFloat(props.item.price)==0">免费</span>' +
        "<span v-else>{{doPrice(props.item.price)[0]}}<em v-text=\"doPrice(props.item.price)[1] ? '.' + doPrice(props.item.price)[1] : '元' \"> </em></span>" +
        '</h5>' +
        '<h6 v-show="selectable" style="display: none"><i v-text="props.item.selectindex"></i></h6>' +
        '</div>' +
        '</div>' +
        '</template>' +
        '</vue-scroller>' +
        '<nodata v-if="!loading && list.length == 0"></nodata>' +
        '</div>' +
        '</div>',

    props: {
        type: { type: Number, default: 0 },
        selectable: { type: Boolean, default: false },
    },
    data: function () {
        return {
            loading: false,
            form: {
                category_id: '',
                currentPage: 1,
                showCount: 20,
                type: 0,
                // width: 1920,
                // height: 1080,
            },
            nomore: false,
            list: [],
            categoryList: [],
        }
    },
    watch: {
        type: function () {
            this.pagesUpdata(true)
        },
    },
    methods: {
        selectTemp: function (item) {
            var that = this
            var referer = this.$urlParam('referer') || ''
            var template = JSON.parse(JSON.stringify(item))

            template.width = template.screeW
            template.height = template.screeH
            template.templateId = template.id
            template.name = template.title
            template.id = 0

            if (!this.selectable) {
                // 进入详情
                // this.$toLink('yunrecipe_detail.html',{id:item.id})
                // template.module = template.data

                localStorage.setItem('maker_disabled', '[]')
                localStorage.setItem('maker_page', JSON.stringify(template))
                this.$toLink('maker_editor.html', {
                    type: 'yunscreen',
                    deviceId: this.$urlParam('deviceId') || '',
                    referer: 'yunrecipe_list.html',
                })

                // this.$toLink('yunscreen_list.html', {
                //     referer: 'yunrecipe_detail.html',
                //     temp: template,
                // })
            } else if (referer == 'yunscreen_program.html') {
                this.$emit('global:yunprogram_list_temp', template)
                this.$toBack()
            } else if (referer == 'maker_page') {
                // 替换模板
                this.$emit('global:maker_retemp', template)
                this.$toBack()
            }
        },

        doPrice: function (price) {
            if (!price && parseInt(price) !== 0) {
                return
            }
            var p = price.toString().split('.')
            return p
        },

        // 获取模版分类
        getTempCategory: function () {
            var that = this
            this.$ajax('yunrecipe_Category', {}, function (res) {
                if (res.code == 200) {
                    var datas = res.data || {}
                    that.categoryList = datas.records || []
                    that.form.category_id = that.categoryList[0].id || ''
                    that.pagesUpdata(true)
                } else {
                    this.$toast(res.message || '请求失败')
                }
            })
        },

        pagesUpdata: function (refresh, callback) {
            var that = this
            var form = that.form

            if (refresh) {
                that.loading = true
            } else {
                if (this.form.nomore) return
            }

            // 分页调整
            form.currentPage = refresh ? 1 : form.currentPage + 1
            form.type = this.type

            this.$ajax('yunrecipe_list', form, function (json) {
                var data = (json || {}).data.records || []
                var pages = that.list
                var width = (document.querySelector('.yc_main_content').offsetWidth - 42) / 2

                // 如果刷新，则清空原数据
                refresh && pages.splice(0, pages.length)

                data.map(function (item) {
                    item.screeW = parseFloat(item.width) || 1
                    item.screeH = parseFloat(item.height) || 1
                    item.paddingBottom = (100 * item.screeH) / item.screeW + '%'
                    item.height = (width * item.screeH) / item.screeW + 57
                    pages.push(item)
                })
                that.loading = false
                that.nomore = data.length < form.showCount
                that.nomore &&
                    that.$nextTick(function () {
                        that.$refs.scroller && that.$refs.scroller.infiniteComplete()
                    })

                callback && callback()
            })
        },

        categorySelect: function (item, index) {
            this.form.category_id = item.id
            this.pagesUpdata(true)
        },
    },
    created: function () {
        this.getTempCategory()
    },
})
